<?php
/***********************************************************************

  Copyright (C) 2002-2007  Rickard Andersson (rickard@punbb.org)

  This file is part of PunBB.

  PunBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/


define('PUN_ROOT', '../');
require PUN_ROOT.'include/common.php';
require PUN_ROOT.'include/common_admin.php';


if (!$pun_user['is_admmod'])
	message($lang_common['No permission']);

// Load the admin.php language file
require PUN_ROOT.'lang/'.$pun_user['language'].'/admin.php';


// Add a censor word
if (isset($_POST['add_word']))
{
	$search_for = trim($_POST['new_search_for']);
	$replace_with = trim($_POST['new_replace_with']);

	if ($search_for == '' || $replace_with == '')
		message($lang_admin['Must enter text message']);

	$db->query('INSERT INTO '.$db->prefix.'censoring (search_for, replace_with) VALUES (\''.$db->escape($search_for).'\', \''.$db->escape($replace_with).'\')') or error('Unable to add censor word', __FILE__, __LINE__, $db->error());

	redirect(pun_link($pun_url['admin_censoring']), $lang_admin['Censor word added'].' '.$lang_admin['Redirect']);
}


// Update a censor word
else if (isset($_POST['update']))
{
	$id = intval(key($_POST['update']));

	$search_for = trim($_POST['search_for'][$id]);
	$replace_with = trim($_POST['replace_with'][$id]);

	if ($search_for == '' || $replace_with == '')
		message($lang_admin['Must enter text message']);

	$db->query('UPDATE '.$db->prefix.'censoring SET search_for=\''.$db->escape($search_for).'\', replace_with=\''.$db->escape($replace_with).'\' WHERE id='.$id) or error('Unable to update censor word', __FILE__, __LINE__, $db->error());

	redirect(pun_link($pun_url['admin_censoring']), $lang_admin['Censor word updated'].' '.$lang_admin['Redirect']);
}


// Remove a censor word
else if (isset($_POST['remove']))
{
	$id = intval(key($_POST['remove']));

	$db->query('DELETE FROM '.$db->prefix.'censoring WHERE id='.$id) or error('Unable to delete censor word', __FILE__, __LINE__, $db->error());

	redirect(pun_link($pun_url['admin_censoring']), $lang_admin['Censor word removed'].' '.$lang_admin['Redirect']);
}


// Setup breadcrumbs
$pun_page['crumbs'] = array(
	array($pun_config['o_board_title'], pun_link($pun_url['index'])),
	array($lang_admin['Forum administration'], pun_link($pun_url['admin_index'])),
	$lang_admin['Censoring']
);

define('PUN_PAGE_SECTION', 'management');
define('PUN_PAGE', 'admin-censoring');
require PUN_ROOT.'header.php';

?>
<div id="pun-main1" class="a-section a-main a-admin">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

<?php echo generate_admin_menu(); ?>

	<div class="b-section b-dataform">
		<div class="c-section c-form">
			<form method="post" accept-charset="utf-8" action="<?php echo pun_link($pun_url['admin_censoring']) ?>?action=foo">
			<div class="panel">
				<input type="hidden" name="csrf_token" value="<?php echo $pun_user['csrf_token'] ?>" />
				<div class="form-intro">
					<h2 class="prefix"><span>Add new censored word: </span></h2>
					<p><?php printf($lang_admin['Add censored word info'], '<a href="'.pun_link($pun_url['admin_options_features']).'#censoring">'.$lang_admin['Options'].' - '.$lang_admin['Features'].'</a>') ?></p>
				</div>
				<fieldset class="textset" id="fs1">
					<legend><span><?php echo $lang_admin['Add censored word legend'] ?></span></legend>
					<p class="field">
						<label for="fs1f1"><?php echo $lang_admin['Censored word'] ?></label><br />
						<span class="input"><input type="text" id="fs1f1" name="new_search_for" size="24" maxlength="60" /></span>
					</p>
					<p class="field">
						<label for="fs1f2"><?php echo $lang_admin['Censored replacement text'] ?></label><br />
						<span class="input"><input type="text" id="fs1f2" name="new_replace_with" size="24" maxlength="60" /></span>
					</p>
				</fieldset>
				<p class="formsubmit"><input type="submit" class="button" name="add_word" value=" <?php echo $lang_admin['Add'] ?> " /></p>
			</div>
			<div class="divider"><hr /></div>
<?php

$result = $db->query('SELECT id, search_for, replace_with FROM '.$db->prefix.'censoring ORDER BY id') or error('Unable to fetch censor word list', __FILE__, __LINE__, $db->error());
if ($db->num_rows($result))
{

?>
			<div class="panel">
				<h2><span><?php echo $lang_admin['Edit censored word legend'] ?></span></h2>
			</div>
<?php

	$i = 3;
	while ($cur_word = $db->fetch_assoc($result))
	{

	?>
			<div class="panel subpanel">
				<fieldset class="textset">
					<legend><span><?php echo $lang_admin['Edit censored word legend'] ?></span></legend>
					<p class="field">
						<label><?php echo $lang_admin['Censored word'] ?></label><br />
						<span class="input"><input type="text" name="search_for[<?php echo $cur_word['id'] ?>]" value="<?php echo htmlspecialchars($cur_word['search_for']) ?>" size="24" maxlength="60" /></span>
					</p>
					<p class="field">
						<label><?php echo $lang_admin['Censored replacement text'] ?></label><br />
						<span class="input"><input type="text" name="replace_with[<?php echo $cur_word['id'] ?>]" value="<?php echo htmlspecialchars($cur_word['replace_with']) ?>" size="24" maxlength="60" /></span>
					</p>
				</fieldset>
				<p class="formsubmit"><input type="submit" class="button" name="update[<?php echo $cur_word['id'] ?>]" value="<?php echo $lang_admin['Update'] ?>" /> <input type="submit" class="button" name="remove[<?php echo $cur_word['id'] ?>]" value="<?php echo $lang_admin['Remove'] ?>" /></p>
			</div>
	<?php

		++$i;
	}
}
else
{

?>
			<div class="panel">
				<div class="form-intro">
					<h2><span><?php echo $lang_admin['Edit censored word legend'] ?></span></h2>
				</div>
				<p><?php echo $lang_admin['No censored words'] ?></p>
			</div>
<?php

}

?>
			</form>
		</div>
	</div>

</div>
<?php

require PUN_ROOT.'footer.php';
