<?php
/***********************************************************************

  Copyright (C) 2002-2007  Rickard Andersson (rickard@punbb.org)

  This file is part of PunBB.

  PunBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/


define('PUN_ROOT', '../');
require PUN_ROOT.'include/common.php';
require PUN_ROOT.'include/common_admin.php';


if ($pun_user['g_id'] != PUN_ADMIN)
	message($lang_common['No permission']);

// Load the admin.php language file
require PUN_ROOT.'lang/'.$pun_user['language'].'/admin.php';


// Add/edit a group (stage 1)
if (isset($_POST['add_group']) || isset($_GET['edit_group']))
{
	if (isset($_POST['add_group']))
	{
		$base_group = intval($_POST['base_group']);

		$result = $db->query('SELECT * FROM '.$db->prefix.'groups WHERE g_id='.$base_group) or error('Unable to fetch user group info', __FILE__, __LINE__, $db->error());
		$group = $db->fetch_assoc($result);

		$mode = 'add';
	}
	else	// We are editing a group
	{
		$group_id = intval($_GET['edit_group']);
		if ($group_id < 1)
			message($lang_common['Bad request']);

		$result = $db->query('SELECT * FROM '.$db->prefix.'groups WHERE g_id='.$group_id) or error('Unable to fetch user group info', __FILE__, __LINE__, $db->error());
		if (!$db->num_rows($result))
			message($lang_common['Bad request']);

		$group = $db->fetch_assoc($result);

		$mode = 'edit';
	}


	// Setup breadcrumbs
	$pun_page['crumbs'] = array(
		array($pun_config['o_board_title'], pun_link($pun_url['index'])),
		array($lang_admin['Forum administration'], pun_link($pun_url['admin_index'])),
		array($lang_admin['Groups'], pun_link($pun_url['admin_groups'])),
		$mode == 'edit' ? $lang_admin['Edit group heading'] : $lang_admin['Add group heading']
	);

	define('PUN_PAGE_SECTION', 'users');
	define('PUN_PAGE', 'admin-groups');
	require PUN_ROOT.'header.php';

?>
<div id="pun-main1" class="a-section a-main a-admin">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

<?php echo generate_admin_menu(); ?>

	<div class="b-section b-dataform">
		<div class="c-section c-form">
			<form method="post" accept-charset="utf-8" action="<?php echo pun_link($pun_url['admin_groups']) ?>">
			<div class="panel">
				<input type="hidden" name="csrf_token" value="<?php echo $pun_user['csrf_token'] ?>" />
				<input type="hidden" name="mode" value="<?php echo $mode ?>" />
<?php if ($mode == 'edit'): ?>				<input type="hidden" name="group_id" value="<?php echo $group_id ?>" />
<?php endif; if ($mode == 'add'): ?>				<input type="hidden" name="base_group" value="<?php echo $base_group ?>" />
<?php endif; ?>				<div class="form-intro">
					<h2 class="prefix"><span><?php echo $lang_admin['Group settings heading'] ?>: </span></h2>
					<p><?php echo $lang_admin['Defaults info'] ?></p>
				</div>
				<p id="req-msg" class="req-warn"><?php printf($lang_common['Required warn'], '<em class="req-text">'.$lang_common['Required mark'].'<span> '.$lang_common['Required'].'</span></em>') ?></p>
				<fieldset class="textset" id="fs1">
					<legend><span><?php echo $lang_admin['Options'] ?></span></legend>
					<p class="field required">
						<label for="fs1f1" class="alabel"><?php echo $lang_admin['Group title'] ?> <em class="req-text"><?php echo $lang_common['Required mark'].' <span>'.$lang_common['Required'].'</span>' ?></em></label><br />
						<span class="input"><input type="text" id="fs1f1" name="req_title" size="25" maxlength="50" value="<?php if ($mode == 'edit') echo htmlspecialchars($group['g_title']); ?>" /></span>
					</p>
					<p class="field">
						<label for="fs1f2"><?php echo $lang_admin['User title'] ?></label><br />
						<span class="input"><input type="text" id="fs1f2" name="user_title" size="25" maxlength="50" value="<?php echo htmlspecialchars($group['g_user_title']) ?>" /> <em class="field-info"><?php echo $lang_admin['User title info'] ?></em></span>
					</p>
<?php ($hook = get_hook('agr_section_settings')) ? eval($hook) : null; ?>
				</fieldset>
<?php if ($group['g_id'] != PUN_ADMIN): ?>				<fieldset class="checkset" id="fs2">
					<legend><span><?php echo $lang_admin['Permissions'] ?></span></legend>
					<p class="field">
<?php if ($group['g_id'] != PUN_ADMIN && $group['g_id'] != PUN_GUEST): ?>						<span class="input"><?php if ($mode == 'edit' && $pun_config['o_default_user_group'] == $group['g_id']) echo $lang_admin['Moderator default group']; else { ?><input type="checkbox" id="fs2f1" name="moderator" value="1"<?php if ($group['g_moderator'] == '1') echo ' checked="checked"' ?> />&#160;<label for="fs2f1"><?php echo $lang_admin['Allow moderate'] ?></label><br /> <em class="field-info"><?php echo $lang_admin['Mods warning'] ?></em><?php } ?></span><br />
<?php endif; if ($group['g_id'] != PUN_ADMIN): ?>						<span class="input"><input type="checkbox" id="fs2f2" name="read_board" value="1"<?php if ($group['g_read_board'] == '1') echo ' checked="checked"' ?> /> <label for="fs2f2"><?php echo $lang_admin['Allow read board'] ?></label><br /> <em class="field-info"><?php echo $lang_admin['Allow read board info'] ?></em></span><br />
						<span class="input"><input type="checkbox" id="fs2f3" name="view_users" value="1"<?php if ($group['g_view_users'] == '1') echo ' checked="checked"' ?> /> <label for="fs2f3"><?php echo $lang_admin['Allow view users'] ?></label></span><br />
						<span class="input"><input type="checkbox" id="fs2f3" name="post_replies" value="1"<?php if ($group['g_post_replies'] == '1') echo ' checked="checked"' ?> /> <label for="fs2f3"><?php echo $lang_admin['Allow post replies'] ?></label></span><br />
						<span class="input"><input type="checkbox" id="fs2f4" name="post_topics" value="1"<?php if ($group['g_post_topics'] == '1') echo ' checked="checked"' ?> /> <label for="fs2f4"><?php echo $lang_admin['Allow post topics'] ?></label></span><br />
						<span class="input"><input type="checkbox" id="fs2f5" name="posts_approved" value="1"<?php if ($group['g_posts_approved'] == '1') echo ' checked="checked"' ?> /> <label for="fs2f5"><?php echo $lang_admin['Allow unapproved post'] ?></label><br /> <em class="field-info"><?php echo $lang_admin['Allow unapproved post info'] ?></em></span><br />
<?php if ($group['g_id'] != PUN_GUEST): ?>						<span class="input"><input type="checkbox" id="fs2f6" name="edit_posts" value="1"<?php if ($group['g_edit_posts'] == '1') echo ' checked="checked"' ?> /> <label for="fs2f6"><?php echo $lang_admin['Allow edit posts'] ?></label></span><br />
						<span class="input"><input type="checkbox" id="fs2f7" name="delete_posts" value="1"<?php if ($group['g_delete_posts'] == '1') echo ' checked="checked"' ?> /> <label for="fs2f7"><?php echo $lang_admin['Allow delete posts'] ?></label></span><br />
						<span class="input"><input type="checkbox" id="fs2f8" name="delete_topics" value="1"<?php if ($group['g_delete_topics'] == '1') echo ' checked="checked"' ?> /> <label for="fs2f8"><?php echo $lang_admin['Allow delete topics'] ?></label></span><br />
						<span class="input"><input type="checkbox" id="fs2f9" name="set_title" value="1"<?php if ($group['g_set_title'] == '1') echo ' checked="checked"' ?> /> <label for="fs2f9"><?php echo $lang_admin['Allow set user title'] ?></label></span><br />
<?php endif; ?>						<span class="input"><input type="checkbox" id="fs2f10" name="search" value="1"<?php if ($group['g_search'] == '1') echo ' checked="checked"' ?> /> <label for="fs2f10"><?php echo $lang_admin['Allow use search'] ?></label></span><br />
						<span class="input"><input type="checkbox" id="fs2f11" name="search_users" value="1"<?php if ($group['g_search_users'] == '1') echo ' checked="checked"' ?> /> <label for="fs2f11"><?php echo $lang_admin['Allow search users'] ?></label></span><br />
<?php ($hook = get_hook('agr_section_permissions')) ? eval($hook) : null; ?>
					</p>
				</fieldset>
<?php if ($group['g_id'] != PUN_GUEST): ?>				<fieldset class="textset" id="fs3">
					<legend><span><?php echo $lang_admin['Restrictions'] ?></span></legend>
					<p class="field">
						<label for="fs3f1" class="alabel"><?php echo $lang_admin['Edit interval'] ?></label><br />
						<span class="input"><input type="text" id="fs3f1" name="edit_subjects_interval" size="5" maxlength="5" value="<?php echo $group['g_edit_subjects_interval'] ?>" /><br /><em class="field-info"><?php echo $lang_admin['Edit interval info'] ?></em></span>
					</p>
					<p class="field">
						<label for="fs3f2" class="alabel"><?php echo $lang_admin['Flood interval'] ?></label><br />
						<span class="input"><input type="text" id="fs3f2" name="post_flood" size="5" maxlength="4" value="<?php echo $group['g_post_flood'] ?>" /><br /> <em class="field-info"><?php echo $lang_admin['Flood interval info'] ?></em></span>
					</p>
					<p class="field">
						<label for="fs3f3" class="alabel"><?php echo $lang_admin['Search interval'] ?></label><br />
						<span class="input"><input type="text" id="fs3f3" name="search_flood" size="5" maxlength="4" value="<?php echo $group['g_search_flood'] ?>" /><br /> <em class="field-info"><?php echo $lang_admin['Search interval info'] ?></em></span>
					</p>
<?php ($hook = get_hook('agr_section_restrictions')) ? eval($hook) : null; ?>
				</fieldset>
<?php endif; endif; endif; ?>				<p class="formsubmit"><input type="submit" class="button" name="add_edit_group" value=" <?php echo $lang_admin['Save'] ?> " /></p>
			</div>
			</form>
		</div>
	</div>

</div>
<?php

	require PUN_ROOT.'footer.php';
}


// Add/edit a group (stage 2)
else if (isset($_POST['add_edit_group']))
{
	// Is this the admin group? (special rules apply)
	$is_admin_group = (isset($_POST['group_id']) && $_POST['group_id'] == PUN_ADMIN) ? true : false;

	$title = trim($_POST['req_title']);
	$user_title = trim($_POST['user_title']);
	$moderator = isset($_POST['moderator']) && $_POST['moderator'] == '1' ? '1' : '0';
	$read_board = isset($_POST['read_board']) && $_POST['read_board'] == '1' ? '1' : '0';
	$view_users = isset($_POST['view_users']) && $_POST['view_users'] == '1' ? '1' : '0';
	$post_replies = isset($_POST['post_replies']) && $_POST['post_replies'] == '1' ? '1' : '0';
	$posts_approved = isset($_POST['posts_approved']) && $_POST['posts_approved'] == '1' ? '1' : '0';
	$post_topics = isset($_POST['post_topics']) && $_POST['post_topics'] == '1' ? '1' : '0';
	$edit_posts = (isset($_POST['edit_posts']) && $_POST['edit_posts'] == '1') || $is_admin_group ? '1' : '0';
	$delete_posts = (isset($_POST['delete_posts']) && $_POST['delete_posts'] == '1') || $is_admin_group ? '1' : '0';
	$delete_topics = (isset($_POST['delete_topics']) && $_POST['delete_topics'] == '1') || $is_admin_group ? '1' : '0';
	$set_title = (isset($_POST['set_title']) && $_POST['set_title'] == '1') || $is_admin_group ? '1' : '0';
	$search = isset($_POST['search']) && $_POST['search'] == '1' ? '1' : '0';
	$search_users = isset($_POST['search_users']) && $_POST['search_users'] == '1' ? '1' : '0';
	$edit_subjects_interval = isset($_POST['edit_subjects_interval']) ? intval($_POST['edit_subjects_interval']) : '0';
	$post_flood = isset($_POST['post_flood']) ? intval($_POST['post_flood']) : '0';
	$search_flood = isset($_POST['search_flood']) ? intval($_POST['search_flood']) : '0';


	if ($title == '')
		message($lang_admin['Must enter group message']);

	$user_title = ($user_title != '') ? '\''.$db->escape($user_title).'\'' : 'NULL';

	if ($_POST['mode'] == 'add')
	{
		$result = $db->query('SELECT 1 FROM '.$db->prefix.'groups WHERE g_title=\''.$db->escape($title).'\'') or error('Unable to check group title collision', __FILE__, __LINE__, $db->error());
		if ($db->num_rows($result))
			message($lang_admin['Already a group message'].' <strong>"'.htmlspecialchars($title).'"</strong>');

		// Insert the new group
		$query = array(
			'INSERT'	=> 'g_title, g_user_title, g_moderator, g_read_board, g_view_users, g_post_replies, g_posts_approved, g_post_topics, g_edit_posts, g_delete_posts, g_delete_topics, g_set_title, g_search, g_search_users, g_edit_subjects_interval, g_post_flood, g_search_flood',
			'INTO'		=> 'groups',
			'VALUES'	=> '\''.$db->escape($title).'\', '.$user_title.', '.$moderator.', '.$read_board.', '.$view_users.', '.$post_replies.', '.$posts_approved.','.$post_topics.', '.$edit_posts.', '.$delete_posts.', '.$delete_topics.', '.$set_title.', '.$search.', '.$search_users.', '.$edit_subjects_interval.', '.$post_flood.', '.$search_flood
		);

		($hook = get_hook('agr_query_add_group')) ? eval($hook) : null;
		$db->query_build($query) or error('Unable to add group', __FILE__, __LINE__, $db->error());
		$new_group_id = $db->insert_id();

		// Now lets copy the forum specific permissions from the group which this group is based on
		$result = $db->query('SELECT forum_id, read_forum, post_replies, post_topics FROM '.$db->prefix.'forum_perms WHERE group_id='.intval($_POST['base_group'])) or error('Unable to fetch group forum permission list', __FILE__, __LINE__, $db->error());
		while ($cur_forum_perm = $db->fetch_assoc($result))
			$db->query('INSERT INTO '.$db->prefix.'forum_perms (group_id, forum_id, read_forum, post_replies, post_topics) VALUES('.$new_group_id.', '.$cur_forum_perm['forum_id'].', '.$cur_forum_perm['read_forum'].', '.$cur_forum_perm['post_replies'].', '.$cur_forum_perm['post_topics'].')') or error('Unable to insert group forum permissions', __FILE__, __LINE__, $db->error());
	}
	else
	{
		$group_id = intval($_POST['group_id']);

		// Make sure admins and guests don't get moderator privileges
		if ($group_id == PUN_ADMIN || $group_id == PUN_GUEST)
			$moderator = '0';

		// Make sure the default group isn't assigned moderator privileges
		if ($moderator == '1' && $pun_config['o_default_user_group'] == $group_id)
			message($lang_admin['Moderator default group']);

		// If the group doesn't have moderator privileges (it might have had before), remove its users from the moderator list in all forums
		if (!$moderator)
		{
			$result = $db->query('SELECT f.id, f.moderators, u.id AS uid FROM '.$db->prefix.'forums AS f RIGHT JOIN '.$db->prefix.'users AS u ON u.group_id = '.$group_id) or error('Unable to fetch users and forums', __FILE__, __LINE__, $db->error());

			while ($cur_forum = $db->fetch_assoc($result))
			{
				$cur_moderators = ($cur_forum['moderators'] != '') ? unserialize($cur_forum['moderators']) : array();

				if (in_array($cur_forum['uid'], $cur_moderators))
				{
					$username = array_search($cur_forum['uid'], $cur_moderators);
					unset($cur_moderators[$username]);
					$cur_moderators = (!empty($cur_moderators)) ? '\''.$db->escape(serialize($cur_moderators)).'\'' : 'NULL';

					$db->query('UPDATE '.$db->prefix.'forums SET moderators='.$cur_moderators.' WHERE id='.$cur_forum['id']) or error('Unable to update forum', __FILE__, __LINE__, $db->error());
				}
			}
		}

		$result = $db->query('SELECT 1 FROM '.$db->prefix.'groups WHERE g_title=\''.$db->escape($title).'\' AND g_id!='.$group_id) or error('Unable to check group title collision', __FILE__, __LINE__, $db->error());
		if ($db->num_rows($result))
			message($lang_admin['Already a group message'].' <strong>"'.htmlspecialchars($title).'"</strong>');

		// Save changes
		$query = array(
			'UPDATE'	=> 'groups',
			'SET'		=> 'g_title=\''.$db->escape($title).'\', g_user_title='.$user_title.', g_moderator='.$moderator.', g_read_board='.$read_board.', g_view_users='.$view_users.', g_post_replies='.$post_replies.', g_posts_approved='.$posts_approved.',g_post_topics='.$post_topics.', g_edit_posts='.$edit_posts.', g_delete_posts='.$delete_posts.', g_delete_topics='.$delete_topics.', g_set_title='.$set_title.', g_search='.$search.', g_search_users='.$search_users.', g_edit_subjects_interval='.$edit_subjects_interval.', g_post_flood='.$post_flood.', g_search_flood='.$search_flood,
			'WHERE'		=> 'g_id='.$group_id
		);

		($hook = get_hook('agr_query_update_group')) ? eval($hook) : null;
		$db->query_build($query) or error('Unable to update group', __FILE__, __LINE__, $db->error());
	}

	// Regenerate the quickjump cache
	require_once PUN_ROOT.'include/cache.php';
	generate_quickjump_cache();

	redirect(pun_link($pun_url['admin_groups']), (($_POST['mode'] == 'edit') ? $lang_admin['Group edited'] : $lang_admin['Group added']).' '.$lang_admin['Redirect']);
}


// Set default group
else if (isset($_POST['set_default_group']))
{
	$group_id = intval($_POST['default_group']);

	// Make sure it's not the admin or guest groups
	if ($group_id == PUN_ADMIN || $group_id == PUN_GUEST)
		message($lang_common['Bad request']);

	// Make sure it's not a moderator group
	$result = $db->query('SELECT g_id FROM '.$db->prefix.'groups WHERE g_id = '.$group_id.' AND g_moderator = 0 LIMIT 1') or error('Unable to fetch group', __FILE__, __LINE__, $db->error());
	if (!$db->num_rows($result))
		message($lang_common['Bad request']);

	$db->query('UPDATE '.$db->prefix.'config SET conf_value='.$group_id.' WHERE conf_name=\'o_default_user_group\'') or error('Unable to update board config', __FILE__, __LINE__, $db->error());

	// Regenerate the config cache
	require_once PUN_ROOT.'include/cache.php';
	generate_config_cache();

	redirect(pun_link($pun_url['admin_groups']), $lang_admin['Default group set'].' '.$lang_admin['Redirect']);
}


// Remove a group
else if (isset($_GET['del_group']))
{
	$group_id = intval($_GET['del_group']);
	if ($group_id < 4)
		message($lang_common['Bad request']);

	// User pressed the cancel button
	if (isset($_POST['del_group_cancel']))
		redirect(pun_link($pun_url['admin_groups']), $lang_admin['Cancel redirect']);

	// Make sure we don't remove the default group
	if ($group_id == $pun_config['o_default_user_group'])
		message($lang_admin['Cannot remove default group']);


	// Check if this group has any members
	$result = $db->query('SELECT g.g_title, COUNT(u.id) FROM '.$db->prefix.'groups AS g INNER JOIN '.$db->prefix.'users AS u ON g.g_id=u.group_id WHERE g.g_id='.$group_id.' GROUP BY g.g_id, g_title') or error('Unable to fetch group info', __FILE__, __LINE__, $db->error());

	// If the group doesn't have any members or if we've already selected a group to move the members to
	if (!$db->num_rows($result) || isset($_POST['del_group']))
	{
		if (isset($_POST['del_group']))
		{
			$move_to_group = intval($_POST['move_to_group']);

			// If we're moving users from a moderator group to a non-moderator group, we remove its users from the moderator list in all forums
			$result = $db->query('SELECT f.id, f.moderators, u.id AS uid FROM '.$db->prefix.'forums AS f RIGHT JOIN '.$db->prefix.'users AS u ON u.group_id = '.$group_id.' INNER JOIN '.$db->prefix.'groups AS g ON u.group_id = g.g_id AND g.g_moderator = 1 INNER JOIN '.$db->prefix.'groups AS ng ON ng.g_id = '.$move_to_group.' AND ng.g_moderator = 0') or error('Unable to fetch users and forums', __FILE__, __LINE__, $db->error());

			while ($cur_forum = $db->fetch_assoc($result))
			{
				$cur_moderators = ($cur_forum['moderators'] != '') ? unserialize($cur_forum['moderators']) : array();

				if (in_array($cur_forum['uid'], $cur_moderators))
				{
					$username = array_search($cur_forum['uid'], $cur_moderators);
					unset($cur_moderators[$username]);
					$cur_moderators = (!empty($cur_moderators)) ? '\''.$db->escape(serialize($cur_moderators)).'\'' : 'NULL';

					$db->query('UPDATE '.$db->prefix.'forums SET moderators='.$cur_moderators.' WHERE id='.$cur_forum['id']) or error('Unable to update forum', __FILE__, __LINE__, $db->error());
				}
			}

			// Move users
			$db->query('UPDATE '.$db->prefix.'users SET group_id='.$move_to_group.' WHERE group_id='.$group_id) or error('Unable to move users into group', __FILE__, __LINE__, $db->error());
		}

		// Delete the group and any forum specific permissions
		$db->query('DELETE FROM '.$db->prefix.'groups WHERE g_id='.$group_id) or error('Unable to delete group', __FILE__, __LINE__, $db->error());
		$db->query('DELETE FROM '.$db->prefix.'forum_perms WHERE group_id='.$group_id) or error('Unable to delete group forum permissions', __FILE__, __LINE__, $db->error());

		// Regenerate the quickjump cache
		require_once PUN_ROOT.'include/cache.php';
		generate_quickjump_cache();

		redirect(pun_link($pun_url['admin_groups']), $lang_admin['Group removed'].' '.$lang_admin['Redirect']);
	}

	list($group_title, $group_members) = $db->fetch_row($result);


	// Setup breadcrumbs
	$pun_page['crumbs'] = array(
		array($pun_config['o_board_title'], pun_link($pun_url['index'])),
		array($lang_admin['Forum administration'], pun_link($pun_url['admin_index'])),
		array($lang_admin['Groups'], pun_link($pun_url['admin_groups'])),
		$lang_admin['Remove group']
	);

	define('PUN_PAGE_SECTION', 'users');
	define('PUN_PAGE', 'admin-groups');
	require PUN_ROOT.'header.php';

?>
<div id="pun-main1" class="a-section a-main a-admin">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

<?php echo generate_admin_menu(); ?>

	<div class="b-section b-dataform">
		<div class="c-section c-form">
			<form class="pun-adcontent" method="post" accept-charset="utf-8" action="<?php echo pun_link($pun_url['admin_groups']) ?>?del_group=<?php echo $group_id ?>">
			<div class="panel">
				<input type="hidden" name="csrf_token" value="<?php echo $pun_user['csrf_token'] ?>" />
				<div class="form-intro">
					<h2 class="prefix"><span><?php echo end($pun_page['crumbs']) ?>: </span></h2>
					<p><?php echo $lang_admin['Remove group intro'] ?></p>
				</div>
				<div class="textset" id="fs1">
					<p class="field">
						<strong class="alabel">Group</strong><br/ >
						<span class="input"><?php echo htmlspecialchars($group_title) ?></span>
					</p>
					<p class="field">
						<strong class="alabel">Members</strong><br/ >
						<span class="input"><?php echo $group_members ?></span>
					</p>
					<p class="field">
						<label for="fs1f1"><?php echo $lang_admin['Move users to'] ?></label><br />
						<span class="input"><select id="fs1f1" name="move_to_group">
<?php

	$result = $db->query('SELECT g_id, g_title FROM '.$db->prefix.'groups WHERE g_id!='.PUN_GUEST.' AND g_id!='.$group_id.' ORDER BY g_title') or error('Unable to fetch user group list', __FILE__, __LINE__, $db->error());

	while ($cur_group = $db->fetch_assoc($result))
	{
		if ($cur_group['g_id'] == PUN_MEMBER)	// Pre-select the pre-defined Members group
			echo "\t\t\t\t\t\t\t\t".'<option value="'.$cur_group['g_id'].'" selected="selected">'.htmlspecialchars($cur_group['g_title']).'</option>'."\n";
		else
			echo "\t\t\t\t\t\t\t\t".'<option value="'.$cur_group['g_id'].'">'.htmlspecialchars($cur_group['g_title']).'</option>'."\n";
	}

?>
						</select></span>
					</p>
				</div>
				<p class="formsubmit"><input type="submit" class="button" name="del_group" value="<?php echo $lang_admin['Remove group'] ?>" /> <input type="submit" class="button" name="del_group_cancel" value="<?php echo $lang_admin['Cancel'] ?>" /></p>
			</div>
			</form>
		</div>
	</div>

</div>
<?php

	require PUN_ROOT.'footer.php';
}


// Setup breadcrumbs
$pun_page['crumbs'] = array(
	array($pun_config['o_board_title'], pun_link($pun_url['index'])),
	array($lang_admin['Forum administration'], pun_link($pun_url['admin_index'])),
	$lang_admin['Groups']
);

define('PUN_PAGE_SECTION', 'users');
define('PUN_PAGE', 'admin-groups');
require PUN_ROOT.'header.php';

?>
<div id="pun-main1" class="a-section a-main a-admin">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

<?php echo generate_admin_menu(); ?>

	<div class="b-section b-dataform">
		<div class="c-section c-form">
			<form method="post" accept-charset="utf-8" action="<?php echo pun_link($pun_url['admin_groups']) ?>?action=foo">
			<div class="panel">
				<input type="hidden" name="csrf_token" value="<?php echo $pun_user['csrf_token'] ?>" />
				<div class="form-intro">
					<h2 class="prefix"><span><?php echo $lang_admin['Add group heading'] ?>: </span></h2>
					<p><?php echo $lang_admin['Add group intro'] ?></p>
				</div>
				<div class="textset" id="fs1">
					<p class="field">
						<label for="fs1f1"><?php echo $lang_admin['Base new group'] ?></label><br />
						<span class="input"><select id="fs1f1" name="base_group">
<?php

$result = $db->query('SELECT g_id, g_title FROM '.$db->prefix.'groups WHERE g_id>'.PUN_GUEST.' ORDER BY g_title') or error('Unable to fetch user group list', __FILE__, __LINE__, $db->error());

while ($cur_group = $db->fetch_assoc($result))
{
	if ($cur_group['g_id'] == $pun_config['o_default_user_group'])
		echo "\t\t\t\t\t\t\t\t".'<option value="'.$cur_group['g_id'].'" selected="selected">'.htmlspecialchars($cur_group['g_title']).'</option>'."\n";
	else
		echo "\t\t\t\t\t\t\t\t".'<option value="'.$cur_group['g_id'].'">'.htmlspecialchars($cur_group['g_title']).'</option>'."\n";
}

?>
						</select></span>
					</p>
				</div>
				<p class="formsubmit"><input type="submit" class="button" name="add_group" value=" <?php echo $lang_admin['Add'] ?> " /></p>
			</div>
			<div class="divider"><hr /></div>
			<div class="panel">
				<div class="form-intro">
					<h2 class="prefix"><span><?php echo $lang_admin['Set default group'] ?>: </span></h2>
					<p><?php echo $lang_admin['Set default group intro'] ?></p>
				</div>
				<div class="textset" id="fs2">
					<p class="field">
						<label for="fs2f1"><?php echo $lang_admin['Default group'] ?></label><br />
						<span class="input"><select id="fs2f1" name="default_group">
<?php

$result = $db->query('SELECT g_id, g_title FROM '.$db->prefix.'groups WHERE g_id>'.PUN_GUEST.' AND g_moderator = 0 ORDER BY g_title') or error('Unable to fetch user group list', __FILE__, __LINE__, $db->error());

while ($cur_group = $db->fetch_assoc($result))
{
	if ($cur_group['g_id'] == $pun_config['o_default_user_group'])
		echo "\t\t\t\t\t\t\t\t".'<option value="'.$cur_group['g_id'].'" selected="selected">'.htmlspecialchars($cur_group['g_title']).'</option>'."\n";
	else
		echo "\t\t\t\t\t\t\t\t".'<option value="'.$cur_group['g_id'].'">'.htmlspecialchars($cur_group['g_title']).'</option>'."\n";
}

?>
						</select></span>
					</p>
				</div>
				<p class="formsubmit"><input type="submit" class="button" name="set_default_group" value=" <?php echo $lang_admin['Save'] ?>" /></p>
			</div>
			</form>
			<div class="divider"><hr /></div>
			<div class="panel">
				<div class="form-intro">
					<h2 class="prefix"><span><?php echo $lang_admin['Existing groups heading'] ?>: </span></h2>
					<p><?php echo $lang_admin['Existing groups intro'] ?></p>
				</div>
				<ul class="textset">
<?php

$result = $db->query('SELECT g_id, g_title FROM '.$db->prefix.'groups ORDER BY g_id') or error('Unable to fetch user group list', __FILE__, __LINE__, $db->error());

while ($cur_group = $db->fetch_assoc($result))
	echo "\n\t\t\t\t\t\t".'<li class="field">'."\n\t\t\t\t\t\t\t".'<strong class="alabel"><a href="'.pun_link($pun_url['admin_groups']).'?edit_group='.$cur_group['g_id'].'">'.$lang_admin['Edit'].'</a>'.(($cur_group['g_id'] > PUN_MEMBER) ? ' - <a href="'.pun_link($pun_url['admin_groups']).'?del_group='.$cur_group['g_id'].'">'.$lang_admin['Remove'].'</a>' : '').'</strong>'."\n\t\t\t\t\t\t\t".'<span class="input">'.htmlspecialchars($cur_group['g_title']).'</span>'."\n\t\t\t\t\t\t".'</li>'."\n";

?>
				</ul>
			</div>
		</div>
	</div>

</div>
<?php

require PUN_ROOT.'footer.php';
