<?php
/***********************************************************************

  Copyright (C) 2002-2007  Rickard Andersson (rickard@punbb.org)

  This file is part of PunBB.

  PunBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/


define('PUN_ROOT', './');
require PUN_ROOT.'include/common.php';


if ($pun_user['g_read_board'] == '0')
	message($lang_common['No view']);

// Load the help.php language file
require PUN_ROOT.'lang/'.$pun_user['language'].'/help.php';


$page_title = htmlspecialchars($pun_config['o_board_title']).' - '.$lang_help['Help'];
define('PUN_PAGE', 'help');
require PUN_ROOT.'header.php';

?>
<div id="pun-main1" class="a-section a-main">

	<div class="main-head">
		<h1 class="main-title"><span><?php echo $lang_help['Help'] ?> [ <a href="#bbcode"><?php echo $lang_common['BBCode'] ?></a> | <a href="#smilies"><?php echo $lang_common['Smilies'] ?></a> ]</span></h1>
	</div>

	<div class="b-section b-dataform">
		<div class="c-section c-form">
			<div id="bbcode" class="panel">
				<div class="form-intro">
					<h2 class="prefix"><span><?php echo $lang_common['BBCode'] ?>: </span></h2>
					<p><?php echo $lang_help['BBCode info 1'] ?></p>
					<p><?php echo $lang_help['BBCode info 2'] ?></p>
				</div>
				<div id="text" class="form-info">
					<h3 class="prefix"><span><?php echo $lang_help['Text style'] ?>: </span></h3>
					<p><?php echo $lang_help['Text style info'] ?></p>
				</div>
				<dl>
					<dt><samp>[b]<?php echo $lang_help['Bold text'] ?>[/b]</samp> <?php echo $lang_help['produces'] ?></dt>
					<dd><b><?php echo $lang_help['Bold text'] ?></b></dd>
					<dt><samp>[u]<?php echo $lang_help['Underlined text'] ?>[/u]</samp> <?php echo $lang_help['produces'] ?></dt>
					<dd><em class="bbuline"><?php echo $lang_help['Underlined text'] ?></em></dd>
					<dt><samp>[i]<?php echo $lang_help['Italic text'] ?>[/i]</samp> <?php echo $lang_help['produces'] ?></dt>
					<dd><i><?php echo $lang_help['Italic text'] ?></i></dd>
					<dt><samp>[color=#FF0000]<?php echo $lang_help['Red text'] ?>[/color]</samp> <?php echo $lang_help['produces'] ?></dt>
					<dd><span style="color: #ff0000"><?php echo $lang_help['Red text'] ?></span></dd>
					<dt><samp>[color=blue]<?php echo $lang_help['Blue text'] ?>[/color]</samp> <?php echo $lang_help['produces'] ?></dt>
					<dd><span style="color: blue"><?php echo $lang_help['Blue text'] ?></span></dd>
				</dl>
				<div id="links" class="form-info">
					<h3 class="prefix"><span><?php echo $lang_help['Links'] ?>: </span></h3>
					<p><?php echo $lang_help['Links info'] ?></p>
				</div>
				<dl>
					<dt><samp>[url=<?php echo $base_url.'/' ?>]<?php echo htmlspecialchars($pun_config['o_board_title']) ?>[/url]</samp> <?php echo $lang_help['produces'] ?></dt>
					<dd><a href="<?php echo $base_url.'/' ?>"><?php echo htmlspecialchars($pun_config['o_board_title']) ?></a></dd>
					<dt><samp>[url]<?php echo $base_url.'/' ?>[/url]</samp> <?php echo $lang_help['produces'] ?></dt>
					<dd><a href="<?php echo $base_url ?>"><?php echo $base_url.'/' ?></a></dd>
					<dt><samp>[email]myname@mydomain.com[/email]</samp> <?php echo $lang_help['produces'] ?></dt>
					<dd><a href="mailto:myname@mydomain.com">myname@mydomain.com</a></dd>
					<dt><samp>[email=myname@mydomain.com]<?php echo $lang_help['My e-mail address'] ?>[/email]</samp> <?php echo $lang_help['produces'] ?></dt>
					<dd><a href="mailto:myname@mydomain.com"><?php echo $lang_help['My e-mail address'] ?></a></dd>
				</dl>
				<div id="img" class="form-info">
					<h3 class="prefix"><span><?php echo $lang_help['Images'] ?>: </span></h3>
					<p><?php echo $lang_help['Images info'] ?></p>
				</div>
				<dl>
					<dt><samp>[img=PunBB logo]http://www.punbb.org/img/small_logo.png[/img]</samp> <?php echo $lang_help['produces'] ?></dt>
					<dd><img src="http://www.punbb.org/img/small_logo.png" alt="PunBB logo" /></dd>
				</dl>
				<div id="quotes" class="form-info">
					<h3 class="prefix"><span><?php echo $lang_help['Quotes with name'] ?>: </span></h3>
					<p><?php echo $lang_help['Quotes info'] ?></p>
				</div>
				<dl>
					<dt><samp>[quote=James]<?php echo $lang_help['Quote text'] ?>[/quote]</samp> <?php echo $lang_help['produces quote box'] ?></dt>
					<dd class="post-entry">
						<div class="entry-content">
							<div class="quotebox"><cite><?php printf($lang_common['User wrote'], 'James') ?>:</cite><blockquote><p><?php echo $lang_help['Quote text'] ?></p></blockquote></div>
						</div>
					</dd>
				</dl>
				<div class="form-info">
					<h3 class="prefix"><span><?php echo $lang_help['Quotes without name'] ?>: </span></h3>
					<p><?php echo $lang_help['Quotes info 2'] ?></p>
				</div>
				<dl>
					<dt><samp>[quote]<?php echo $lang_help['Quote text'] ?>[/quote]</samp> <?php echo $lang_help['produces quote box'] ?></dt>
					<dd class="post-entry">
						<div class="entry-content">
							<div class="quotebox"><blockquote><p><?php echo $lang_help['Quote text'] ?></p></blockquote></div>
						</div>
					</dd>
				</dl>
				<div id="code" class="form-info">
					<h3 class="prefix"><span><?php echo $lang_help['Code'] ?>: </span></h3>
					<p><?php echo $lang_help['Code info'] ?></p>
				</div>
				<dl>
					<dt><samp>[code]<?php echo $lang_help['Code text'] ?>[/code]</samp> <?php echo $lang_help['produces code box'] ?></dt>
					<dd class="post-entry">
						<div class="entry-content">
							<div class="codebox"><strong class="alegend"><?php echo $lang_common['Code'] ?>:</strong><pre><code><?php echo $lang_help['Code text'] ?></code></pre></div>
						</div>
					</dd>
				</dl>
				<div id="nested" class="form-info">
					<h3 class="prefix"><span><?php echo $lang_help['Nested tags'] ?>: </span></h3>
					<p><?php echo $lang_help['Nested tags info'] ?></p>
				</div>
				<dl>
					<dt><samp>[b][u]<?php echo $lang_help['Bold, underlined text'] ?>[/u][/b]</samp> <?php echo $lang_help['produces'] ?></dt>
					<dd><em class="bbuline"><b><?php echo $lang_help['Bold, underlined text'] ?></b></em></dd>
				</dl>
			</div>

			<div id="smilies" class="panel">
				<div class="form-intro">
					<h2 class="prefix"><span><?php echo $lang_common['Smilies'] ?>: </span></h2>
					<p><?php echo $lang_help['Smilies info'] ?></p>
				</div>
				<ul>
<?php

// Display the smiley set
require PUN_ROOT.'include/parser.php';

$num_smilies = count($smiley_text);
for ($i = 0; $i < $num_smilies; ++$i)
{
	// Is there a smiley at the current index?
	if (!isset($smiley_text[$i]))
		continue;

	echo "\t\t\t\t\t".'<li>'.$smiley_text[$i];

	// Save the current text and image
	$cur_img = $smiley_img[$i];
	$cur_text = $smiley_text[$i];

	// Loop through the rest of the array and see if there are any duplicate images
	// (more than one text representation for one image)
	for ($next = $i + 1; $next < $num_smilies; ++$next)
	{
		// Did we find a dupe?
		if (isset($smiley_img[$next]) && $smiley_img[$i] == $smiley_img[$next])
		{
			echo ' '.$lang_common['and'].' '.$smiley_text[$next];

			// Remove the dupe so we won't display it twice
			unset($smiley_text[$next]);
			unset($smiley_img[$next]);
		}
	}

	echo ' '.$lang_help['produces'].' <img src="img/smilies/'.$cur_img.'" width="15" height="15" alt="'.$cur_text.'" /></li>'."\n";
}

?>
				</ul>
			</div>
		</div>
	</div>

</div>
<?php

require PUN_ROOT.'footer.php';
