<?php
/***********************************************************************

  Copyright (C) 2002-2007  Rickard Andersson (rickard@punbb.org)

  This file is part of PunBB.

  PunBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

// Make sure no one attempts to run this script "directly"
if (!defined('PUN'))
	exit;


//
// Display the admin navigation menu
//
function generate_admin_menu()
{
	global $pun_config, $pun_url, $pun_user, $lang_admin, $db_type;

	$adnav_sublinks = array();

	if ($pun_user['g_id'] != PUN_ADMIN)
	{
		$adnav_sublinks[] = '<li'.((PUN_PAGE == 'admin-information') ? ' class="li-first isactive">' : ' class="li-first">').'<a href="'.pun_link($pun_url['admin_index']).'">'.$lang_admin['Information'].'</a></li>';
		$adnav_sublinks[] = '<li'.((PUN_PAGE == 'admin-users') ? ' class="isactive"' : '').'><a href="'.pun_link($pun_url['admin_users']).'">'.$lang_admin['User search'].'</a></li>';
		$adnav_sublinks[] = '<li'.((PUN_PAGE == 'admin-censoring') ? ' class="isactive">' : '>').'<a href="'.pun_link($pun_url['admin_censoring']).'">'.$lang_admin['Censoring'].'</a></li>';
		$adnav_sublinks[] = '<li'.((PUN_PAGE == 'admin-reports') ? ' class="isactive">' : '>').'<a href="'.pun_link($pun_url['admin_reports']).'">'.$lang_admin['Reports'].'</a></li>';

		if ($pun_config['p_mod_ban_users'] == '1')
			$adnav_sublinks[] = '<li'.((PUN_PAGE == 'admin-bans') ? ' class="isactive">' : '>').'<a href="'.pun_link($pun_url['admin_bans']).'">'.$lang_admin['Bans'].'</a></li>';
	}
	else
	{
		if (PUN_PAGE_SECTION == 'setup')
		{
			$adnav_sublinks[] = '<li'.((PUN_PAGE == 'admin-information') ? ' class="isactive"' : '').'><a href="'.pun_link($pun_url['admin_index']).'">'.$lang_admin['Information'].'</a></li>';
			$adnav_sublinks[] = '<li'.((PUN_PAGE == 'admin-categories') ? ' class="isactive"' : '').'><a href="'.pun_link($pun_url['admin_categories']).'">'.$lang_admin['Categories'].'</a></li>';
			$adnav_sublinks[] = '<li'.((PUN_PAGE == 'admin-forums') ? ' class="isactive"' : '').'><a href="'.pun_link($pun_url['admin_forums']).'">'.$lang_admin['Forums'].'</a></li>';
		}
		else if (PUN_PAGE_SECTION == 'users')
		{
			$adnav_sublinks[] = '<li'.((PUN_PAGE == 'admin-users') ? ' class="isactive"' : '').'><a href="'.pun_link($pun_url['admin_users']).'">'.$lang_admin['Searches'].'</a></li>';
			$adnav_sublinks[] = '<li'.((PUN_PAGE == 'admin-groups') ? ' class="isactive"' : '').'><a href="'.pun_link($pun_url['admin_groups']).'">'.$lang_admin['Groups'].'</a></li>';
			$adnav_sublinks[] = '<li'.((PUN_PAGE == 'admin-ranks') ? ' class="isactive"' : '').'><a href="'.pun_link($pun_url['admin_ranks']).'">'.$lang_admin['Ranks'].'</a></li>';
			$adnav_sublinks[] = '<li'.((PUN_PAGE == 'admin-bans') ? ' class="isactive"' : '').'><a href="'.pun_link($pun_url['admin_bans']).'">'.$lang_admin['Bans'].'</a></li>';
		}
		else if (PUN_PAGE_SECTION == 'options')
		{
			$adnav_sublinks[] = '<li'.((PUN_PAGE == 'admin-options-essentials') ? ' class="isactive"' : '').'><a href="'.pun_link($pun_url['admin_options_essentials']).'">'.$lang_admin['Essentials'].'</a></li>';
			$adnav_sublinks[] = '<li'.((PUN_PAGE == 'admin-options-features') ? ' class="isactive"' : '').'><a href="'.pun_link($pun_url['admin_options_features']).'">'.$lang_admin['Features'].'</a></li>';
			$adnav_sublinks[] = '<li'.((PUN_PAGE == 'admin-options-content') ? ' class="isactive"' : '').'><a href="'.pun_link($pun_url['admin_options_content']).'">'.$lang_admin['Content'].'</a></li>';
			$adnav_sublinks[] = '<li'.((PUN_PAGE == 'admin-options-communications') ? ' class="isactive"' : '').'><a href="'.pun_link($pun_url['admin_options_communications']).'">'.$lang_admin['Communications'].'</a></li>';
			$adnav_sublinks[] = '<li'.((PUN_PAGE == 'admin-options-registration') ? ' class="isactive"' : '').'><a href="'.pun_link($pun_url['admin_options_registration']).'">'.$lang_admin['Registration'].'</a></li>';
		}
		else if (PUN_PAGE_SECTION == 'management')
		{
			$adnav_sublinks[] = '<li'.((PUN_PAGE == 'admin-reports') ? ' class="isactive"' : '').'><a href="'.pun_link($pun_url['admin_reports']).'">'.$lang_admin['Reports'].'</a></li>';
			$adnav_sublinks[] = '<li'.((PUN_PAGE == 'admin-censoring') ? ' class="isactive"' : '').'><a href="'.pun_link($pun_url['admin_censoring']).'">'.$lang_admin['Censoring'].'</a></li>';
			$adnav_sublinks[] = '<li'.((PUN_PAGE == 'admin-prune') ? ' class="isactive"' : '').'><a href="'.pun_link($pun_url['admin_prune']).'">'.$lang_admin['Prune old posts'].'</a></li>';

			// Commented out by Paul because I needed to test the output
			//if ($db_type != 'mysql' && $db_type != 'mysqli')
				$adnav_sublinks[] = '<li'.((PUN_PAGE == 'admin-reindex') ? ' class="isactive"' : '').'><a href="'.pun_link($pun_url['admin_reindex']).'">'.$lang_admin['Rebuild index'].'</a></li>';
		}

		else if (PUN_PAGE_SECTION == 'extensions')
		{
			$adnav_sublinks[] = '<li'.((PUN_PAGE == 'admin-extensions') ? ' class="isactive"' : '').'><a href="'.pun_link($pun_url['admin_extensions']).'">'.$lang_admin['Manage extensions'].'</a></li>';
		}

	}

	if (count($adnav_sublinks) > 1)
		$adnav_submenu = "\n\t\t\t\t".'<ul>'."\n\t\t\t\t\t".implode("\n\t\t\t\t\t", $adnav_sublinks)."\n\t\t\t\t".'</ul>';
	else
		$adnav_submenu = '';

	if ($pun_user['g_id'] != PUN_ADMIN)
		$adnav_links[] = '<li class="topactive"><strong><a href="'.pun_link($pun_url['admin_index']).'">'.$lang_admin['Moderate'].'</a></strong>'.$adnav_submenu."\n\t\t\t".'</li>';
	else
	{
		$adnav_links[] = '<li'.((PUN_PAGE_SECTION == 'setup') ? ' class="topactive"' : '').'><strong><a href="'.pun_link($pun_url['admin_index']).'">'.$lang_admin['Setup'].'</a></strong>'.(((PUN_PAGE_SECTION == 'setup') && ($adnav_submenu != '')) ? $adnav_submenu."\n\t\t\t" : '').'</li>';
		$adnav_links[] = '<li'.((PUN_PAGE_SECTION == 'users') ? ' class="topactive"' : '').'><strong><a href="'.pun_link($pun_url['admin_users']).'">'.$lang_admin['Users'].'</a></strong>'.(((PUN_PAGE_SECTION == 'users') && ($adnav_submenu != '')) ? $adnav_submenu."\n\t\t\t" : '').'</li>';
		$adnav_links[] = '<li'.((PUN_PAGE_SECTION == 'options') ? ' class="topactive"' : '').'><strong><a href="'.pun_link($pun_url['admin_options_essentials']).'">'.$lang_admin['Options'].'</a></strong>'.(((PUN_PAGE_SECTION == 'options') && ($adnav_submenu != '')) ? $adnav_submenu."\n\t\t\t" : '').'</li>';
		$adnav_links[] = '<li'.((PUN_PAGE_SECTION == 'management') ? ' class="topactive"' : '').'><strong><a href="'.pun_link($pun_url['admin_reports']).'">'.$lang_admin['Management'].'</a></strong>'.(((PUN_PAGE_SECTION == 'management') && ($adnav_submenu != '')) ? $adnav_submenu."\n\t\t\t" : '').'</li>';
		$adnav_links[] = '<li'.((PUN_PAGE_SECTION == 'extensions') ? ' class="topactive"' : '').'><strong><a href="'.pun_link($pun_url['admin_extensions']).'">'.$lang_admin['Extensions'].'</a></strong>'.(((PUN_PAGE_SECTION == 'extensions') && ($adnav_submenu != '')) ? $adnav_submenu."\n\t\t\t" : '').'</li>';
	}

?>
	<div id="admin-nav" class="main-nav<?php if ($adnav_submenu != '') echo ' submenu' ?>">
		<ul>
			<?php echo implode("\n\t\t\t", $adnav_links)."\n" ?>
		</ul>
	</div>
<?php

}


//
// Delete topics from $forum_id that are "older than" $prune_date (if $prune_sticky is 1, sticky topics will also be deleted)
//
function prune($forum_id, $prune_sticky, $prune_date)
{
	global $db;

	$extra_sql = ($prune_date != -1) ? ' AND last_post<'.$prune_date : '';

	if (!$prune_sticky)
		$extra_sql .= ' AND sticky=\'0\'';

	// Fetch topics to prune
	$result = $db->query('SELECT id FROM '.$db->prefix.'topics WHERE forum_id='.$forum_id.$extra_sql, true) or error('Unable to fetch topics', __FILE__, __LINE__, $db->error());

	$topic_ids = '';
	while ($row = $db->fetch_row($result))
		$topic_ids .= (($topic_ids != '') ? ',' : '').$row[0];

	if ($topic_ids != '')
	{
		// Fetch posts to prune
		$result = $db->query('SELECT id FROM '.$db->prefix.'posts WHERE topic_id IN('.$topic_ids.')', true) or error('Unable to fetch posts', __FILE__, __LINE__, $db->error());

		$post_ids = '';
		while ($row = $db->fetch_row($result))
			$post_ids .= (($post_ids != '') ? ',' : '').$row[0];

		if ($post_ids != '')
		{
			// Delete topics
			$db->query('DELETE FROM '.$db->prefix.'topics WHERE id IN('.$topic_ids.')') or error('Unable to prune topics', __FILE__, __LINE__, $db->error());
			// Delete subscriptions
			$db->query('DELETE FROM '.$db->prefix.'subscriptions WHERE topic_id IN('.$topic_ids.')') or error('Unable to prune subscriptions', __FILE__, __LINE__, $db->error());
			// Delete posts
			$db->query('DELETE FROM '.$db->prefix.'posts WHERE id IN('.$post_ids.')') or error('Unable to prune posts', __FILE__, __LINE__, $db->error());

			// We removed a bunch of posts, so now we have to update the search index
			if ($db_type != 'mysql' && $db_type != 'mysqli')
			{
				require_once PUN_ROOT.'include/search_idx.php';
				strip_search_index($post_ids);
			}
		}
	}
}
