<?php
/***********************************************************************

  Copyright (C) 2002-2007  Rickard Andersson (rickard@punbb.org)

  This file is part of PunBB.

  PunBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

// Make sure no one attempts to run this script "directly"
if (!defined('PUN'))
	exit;

// These are the regular, "non-SEF" URLs (you probably don't want to edit these)
$pun_url = array(
	'change_email'					=>	'profile.php?action=change_email&amp;id=$1',
	'change_email_key'				=>	'profile.php?action=change_email&amp;id=$1&amp;key=$2',
	'change_password'				=>	'profile.php?action=change_pass&amp;id=$1',
	'change_password_key'			=>	'profile.php?action=change_pass&amp;id=$1&amp;key=$2',
	'delete'						=>	'delete.php?id=$1',
	'delete_avatar'					=>	'profile.php?action=delete_avatar&amp;id=$1',
	'edit'							=>	'edit.php?id=$1',
	'email'							=>	'misc.php?email=$1',
	'forum'							=>	'viewforum.php?id=$1',
	'forum_rss'						=>	'extern.php?action=feed&amp;fid=$1&amp;type=rss',
	'forum_atom'					=>	'extern.php?action=feed&amp;fid=$1&amp;type=atom',
	'help'							=>	'help.php#$1',
	'index'							=>	'',
	'login'							=>	'login.php',
	'logout'						=>	'login.php?action=out&amp;id=$1',
	'mark_read'						=>	'misc.php?action=markread',
	'new_topic'						=>	'post.php?fid=$1',
	'new_reply'						=>	'post.php?tid=$1',
	'post'							=>	'viewtopic.php?pid=$1#p$1',
	'profile_identity'				=>	'profile.php?section=identity&amp;id=$1',
	'profile_preferences'			=>	'profile.php?section=preferences&amp;id=$1',
	'profile_avatar'				=>	'profile.php?section=avatar&amp;id=$1',
	'profile_signature'				=>	'profile.php?section=signature&amp;id=$1',
	'profile_display'				=>	'profile.php?section=display&amp;id=$1',
	'profile_privacy'				=>	'profile.php?section=privacy&amp;id=$1',
	'profile_admin'					=>	'profile.php?section=admin&amp;id=$1',
	'quote'							=>	'post.php?tid=$1&amp;qid=$2',
	'register'						=>	'register.php',
	'report'						=>	'misc.php?report=$1',
	'approve'						=>	'misc.php?approve=$1',
	'request_password'				=>	'login.php?action=forget',
	'rules'							=>	'misc.php?action=rules',
	'search'						=>	'search.php',
	'search_resultft'				=>	'search.php?action=search&amp;keywords=$1&amp;author=$3&amp;forum=$2&amp;search_in=$4&amp;sort_by=$5&amp;sort_dir=$6&amp;show_as=$7',
	'search_results'				=>	'search.php?search_id=$1',
	'search_new'					=>	'search.php?action=show_new',
	'search_24h'					=>	'search.php?action=show_recent',
	'search_unanswered'				=>	'search.php?action=show_unanswered',
	'search_subscriptions'			=>	'search.php?action=show_subscriptions',
	'search_user'					=>	'search.php?action=show_user&amp;user_id=$1',
	'subscribe'						=>	'misc.php?subscribe=$1',
	'topic'							=>	'viewtopic.php?id=$1',
	'topic_rss'						=>	'extern.php?action=feed&amp;tid=$1&amp;type=rss',
	'topic_atom'					=>	'extern.php?action=feed&amp;tid=$1&amp;type=atom',
	'topic_new_posts'				=>	'viewtopic.php?id=$1&amp;action=new',
	'topic_last_post'				=>	'viewtopic.php?id=$1&amp;action=last',
	'unsubscribe'					=>	'misc.php?unsubscribe=$1',
	'upload_avatar'					=>	'profile.php?action=upload_avatar&amp;id=$1',
	'user'							=>	'profile.php?id=$1',
	'users'							=>	'userlist.php',
	'users_browse'					=>	'userlist.php?show_group=$1&amp;sort_by=$2&amp;sort_dir=$3&amp;username=$4',
	'page'							=>	'&amp;p=$1',
	'moderate'						=>	'moderate.php',
	'moderate_forum'				=>	'moderate.php?fid=$1',
	'get_host'						=>	'moderate.php?get_host=$1',
	'move'							=>	'moderate.php?fid=$1&amp;move_topics=$2',
	'open'							=>	'moderate.php?fid=$1&amp;open=$2',
	'close'							=>	'moderate.php?fid=$1&amp;close=$2',
	'stick'							=>	'moderate.php?fid=$1&amp;stick=$2',
	'unstick'						=>	'moderate.php?fid=$1&amp;unstick=$2',
	'delete_multiple'				=>	'moderate.php?fid=$1&amp;tid=$2',
	'approve_multiple'				=>	'moderate.php?fid=$1&amp;tid=$2&amp;approve=1',
	'admin_index'					=>	'admin/index.php',
	'admin_bans'					=>	'admin/bans.php',
	'admin_categories'				=>	'admin/categories.php',
	'admin_censoring'				=>	'admin/censoring.php',
	'admin_extensions'				=>	'admin/extensions.php',
	'admin_forums'					=>	'admin/forums.php',
	'admin_groups'					=>	'admin/groups.php',
	'admin_loader'					=>	'admin/loader.php',
	'admin_reindex'					=>	'admin/reindex.php',
	'admin_options_essentials'		=>	'admin/options.php?section=essentials',
	'admin_options_features'		=>	'admin/options.php?section=features',
	'admin_options_content'			=>	'admin/options.php?section=content',
	'admin_options_registration'	=>	'admin/options.php?section=registration',
	'admin_options_communications'	=>	'admin/options.php?section=communications',
	'admin_prune'					=>	'admin/prune.php',
	'admin_ranks'					=>	'admin/ranks.php',
	'admin_reports'					=>	'admin/reports.php',
	'admin_users'					=>	'admin/users.php'
);