<?php

// Language definitions used in profile.php
$lang_profile = array(

// Navigation and sections
'View profile'				=>	'%s\'s profile',
'Users profile'				=>	'%s\'s profile (%s)',
'Section identity'			=>	'Identity',
'Section preferences'		=>	'Preferences',
'Section signature'			=>	'Signature',
'Section avatar'			=>	'Avatar',
'Section display'			=>	'Display',
'Section admin'				=>	'Administration',

// Identity Section
'Identity intro'			=>	'Enter your personal and contact details. The information you enter will be displayed to other users subject to any preferences you set for the display of your e-mail address.',
'Identity intro options'	=>	'Additional options are available via the links appearing below.',
'Personal legend'			=>	'Personal details',
'Contact legend'			=>	'Contact details',
'Realname'					=>	'Real name',
'Location'					=>	'Location',
'Admin note'				=>	'Admin note',
'Website'					=>	'Website',
'Jabber'					=>	'Jabber',
'ICQ'						=>	'ICQ',
'MSN'						=>	'MSN Messenger',
'AOL IM'					=>	'AOL IM',
'Yahoo'						=>	'Yahoo! Messenger',
'Change pass'				=>	'Change password',
'Change e-mail'				=>	'Change e-mail address',

// E-mail stuff
'E-mail key bad'			=>	'The specified e-mail activation key was incorrect or has expired. Please re-request change of e-mail address. If that fails, contact the forum administrator at %s.',
'E-mail updated'			=>	'Your e-mail address has been updated.',
'Activate e-mail sent'		=>	'An email has been sent to the specified address with instructions on how to activate the new e-mail address. If it doesn\'t arrive you can contact the forum administrator at %s.',
'E-mail instructions'		=>	'An e-mail will be sent to your new address with an activation link. You must click the link in the e-mail you receive to activate the new address. You must therefore ensure that you enter a valid and current e-mail address.',
'New e-mail'				=>	'New e-mail address',

// Password stuff
'Pass key bad'				=>	'The specified password activation key was incorrect or has expired. Please re-request a new password. If that fails, contact the forum administrator at %s.',
'Pass logout'				=>	'A user is currently logged in. Please logout and try again.',
'Pass updated'				=>	'Your password has been updated. You can now login with your new password.',
'Pass updated redirect'		=>	'Password updated. Redirecting …',
'Wrong pass'				=>	'Wrong old password.',
'Old pass'					=>	'Old password',
'Old pass info'				=>	'You must first enter your existing password',
'New pass'					=>	'New password',
'Re-enter new pass'			=>	'Re-enter new password',

// Preferences section
'Preferences intro'			=>	'For the forum to display times correctly you must select your local timezone. Enabling daylight savings will advance times by one hour. You may choose how dates and times are displayed using the time and date format options. You may choose to display or hide your email address and whether you wish to receive email via the forum. You may also set options for subscriptions and whether you wish to be automatically logged in to the forum on each visit.',
'Time format'				=>  'Time display format',
'Date format'				=>  'Date display format',
'Default'					=>  'default',
'Subscription legend'		=>	'Subscription options',
'Notify full'				=>	'Include a plain text copy of posts in subscription e-mails.',
'Subscribe by default'		=>	'Subscribe to topics by default when posting.',

// Avatar upload stuff
'Avatars disabled'			=>	'The administrator has disabled avatar support.',
'Too large ini'				=>	'The selected file was too large to upload. The server didn\'t allow the upload.',
'Partial upload'			=>	'The selected file was only partially uploaded. Please try again.',
'No tmp directory'			=>	'PHP was unable to save the uploaded file to a temporary location.',
'No file'					=>	'You did not select a file for upload.',
'Bad type'					=>	'The file you tried to upload is not of an allowed type. Allowed types are gif, jpeg and png.',
'Too wide or high'			=>	'The file you tried to upload is wider and/or higher than the maximum allowed %sx%s pixels.',
'Too large'					=>	'The file you tried to upload is larger than the maximum allowed %s bytes.',
'Move failed'				=>	'The server was unable to save the uploaded file. Please contact the forum administrator at %s.',
'Unknown failure'			=>	'An unknown error occurred. Please try again.',
'Avatar deleted redirect'	=>	'Avatar deleted. Redirecting …',
'Avatar intro 1'			=>	'An avatar is a small image that will be displayed under your username in your posts. It must not be any bigger than %sx%s pixels and %s bytes (%s KB).',
'Avatar intro 2'			=>	'You do not currently have an avatar. To display an avatar with your posts you first need to upload one.',
'Avatar intro 3'			=>	'Your current avatar is displayed below. To change it, upload a new one and it will automatically replace the old one. If you no longer wish to display an avatar with your posts, click the delete avatar link.',
'Upload avatar file'		=>	'Upload avatar file',
'Avatar legend'				=>	'Upload or delete avatar',
'Delete avatar'				=>	'Delete avatar',
'Current avatar'			=>	'Current avatar',

// Display section
'Display intro 1'			=>	'You may choose a style for viewing the forum which will automatically be selected each time you login.',
'Display intro 2'			=>	'If you are on a slow connection you should consider disabling the display of images in posts and signatures. If you are navigating with a keyboard you should consider reducing the number of posts displayed per page.',
'Display legend'			=>	'Set your display options',
'Styles'					=>	'Available styles',
'Post display legend'		=>	'Post display options',
'Show smilies'				=>	'Show smilies as graphic icons.',
'Show images'				=>	'Show images in posts.',
'Show images sigs'			=>	'Show images in user signatures.',
'Show avatars'				=>	'Show user avatars in posts.',
'Show sigs'					=>	'Show user signatures.',
'Pagination options'		=>	'Pagination options',
'Topics per page'			=>	'Topics per page',
'Posts per page'			=>	'Posts per page',

// Form validation stuff
'Forbidden title'			=>	'The title you entered contains a forbidden word. You must choose a different title.',
'Profile redirect'			=>	'Profile updated. Redirecting …',

// Profile display stuff
'Unknown'					=>	'(Unknown)',	// This is displayed when a user hasn't filled out profile field (e.g. Location)
'Private'					=>	'(Private)',	// This is displayed when a user does not want to receive e-mails
'No avatar'					=>	'(No avatar)',
'Show posts'				=>	'Show all posts',
'Avatar'					=>	'Avatar',
'Signatures disabled'		=>	'The administrator has disabled signatures support.',
'Signature'					=>	'Signature',
'Sig max length'			=>	'Max length',
'Sig max lines'				=>	'Max lines',
'Signature info'			=>	'A signature is a small piece of text that is attached to your posts. In it, you can enter just about anything you like. Perhaps you would like to enter your favourite quote or your star sign. It\'s up to you! In your signature you can use BBCode if it is allowed in this particular forum. You current signature, if any, is previewed below.',
'Compose signature'			=>	'Compose signature',
'No sig'					=>	'No signature currently stored in profile.',
'Leave blank'				=>	'Leave blank to use forum default.',
'Instructions'				=>	'When you update your profile, you will be redirected back to this page.',

// Administration stuff
'User management legend'	=>	'User management',
'User group'				=>	'User group',
'Save'						=>	'Save',
'Set mods legend'			=>	'Set moderator access',
'Moderator in info'			=>	'Choose what forums this user should be allowed to moderate. Note: This only applies to moderators. Administrators always have full permissions in all forums.',
'Update forums'				=>	'Update forums',
'Ban user info'				=>	'Ban this user via the administration console.',
'Delete user'				=>	'Delete user',
'Ban user'					=>	'Ban user',
'Delete warning'			=>	'Deleted users and/or posts cannot be restored. If you choose not to delete the posts made by this user, the posts can only be deleted manually at a later time.',
'Delete posts legend'		=>	'Delete posts',
'Delete posts label'		=>	'Delete any posts and topics this user has made.',
'Delete'					=>	'Delete',		// submit button (confirm user delete)
'User delete redirect'		=>	'User deleted. Redirecting …',
'Group membership redirect'	=>	'Group membership saved. Redirecting …',
'Update forums redirect'	=>	'Forum moderator rights updated. Redirecting …',
'Ban redirect'				=>	'Redirecting …',
'Category'					=>	'Category',
'Mod set legend'			=>	'Select forum'

);
