<?php
/***********************************************************************

  Copyright (C) 2002-2007  Rickard Andersson (rickard@punbb.org)

  This file is part of PunBB.

  PunBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/


define('PUN_ROOT', './');
require PUN_ROOT.'include/common.php';


if ($pun_user['g_read_board'] == '0')
	message($lang_common['No view']);

// Load the post.php language file
require PUN_ROOT.'lang/'.$pun_user['language'].'/post.php';


$tid = isset($_GET['tid']) ? intval($_GET['tid']) : 0;
$fid = isset($_GET['fid']) ? intval($_GET['fid']) : 0;
if ($tid < 1 && $fid < 1 || $tid > 0 && $fid > 0)
	message($lang_common['Bad request']);


// Fetch some info about the topic and/or the forum
if ($tid)
	$result = $db->query('SELECT f.id, f.forum_name, f.moderators, f.approval, f.redirect_url, fp.post_replies, fp.post_topics, t.subject, t.closed, s.user_id AS is_subscribed FROM '.$db->prefix.'topics AS t INNER JOIN '.$db->prefix.'forums AS f ON f.id=t.forum_id LEFT JOIN '.$db->prefix.'forum_perms AS fp ON (fp.forum_id=f.id AND fp.group_id='.$pun_user['g_id'].') LEFT JOIN '.$db->prefix.'subscriptions AS s ON (t.id=s.topic_id AND s.user_id='.$pun_user['id'].') WHERE (fp.read_forum IS NULL OR fp.read_forum=1) AND t.id='.$tid) or error('Unable to fetch forum info', __FILE__, __LINE__, $db->error());
else
	$result = $db->query('SELECT f.id, f.forum_name, f.moderators, f.approval, f.redirect_url, fp.post_replies, fp.post_topics FROM '.$db->prefix.'forums AS f LEFT JOIN '.$db->prefix.'forum_perms AS fp ON (fp.forum_id=f.id AND fp.group_id='.$pun_user['g_id'].') WHERE (fp.read_forum IS NULL OR fp.read_forum=1) AND f.id='.$fid) or error('Unable to fetch forum info', __FILE__, __LINE__, $db->error());

if (!$db->num_rows($result))
	message($lang_common['Bad request']);

$cur_posting = $db->fetch_assoc($result);
$is_subscribed = $tid && $cur_posting['is_subscribed'];

// Is someone trying to post into a redirect forum?
if ($cur_posting['redirect_url'] != '')
	message($lang_common['Bad request']);

// Sort out who the moderators are and if we are currently a moderator (or an admin)
$mods_array = ($cur_posting['moderators'] != '') ? unserialize($cur_posting['moderators']) : array();
$is_admmod = ($pun_user['g_id'] == PUN_ADMIN || ($pun_user['g_moderator'] == '1' && array_key_exists($pun_user['username'], $mods_array))) ? true : false;

// Do we have permission to post?
if ((($tid && (($cur_posting['post_replies'] == '' && $pun_user['g_post_replies'] == '0') || $cur_posting['post_replies'] == '0')) ||
	($fid && (($cur_posting['post_topics'] == '' && $pun_user['g_post_topics'] == '0') || $cur_posting['post_topics'] == '0')) ||
	(isset($cur_posting['closed']) && $cur_posting['closed'] == '1')) &&
	!$is_admmod)
	message($lang_common['No permission']);

// Does the post need to be approved?
$approved = ($cur_posting['approval'] == 1 && $pun_user['g_posts_approved'] == 0 && !$is_admmod) ? 0 : 1;


// Start with a clean slate
$errors = array();

// Did someone just hit "Submit" or "Preview"?
if (isset($_POST['form_sent']))
{
	// Make sure form_user is correct
	if (($pun_user['is_guest'] && $_POST['form_user'] != 'Guest') || (!$pun_user['is_guest'] && $_POST['form_user'] != $pun_user['username']))
		message($lang_common['Bad request']);

	// Flood protection
	if (!$pun_user['is_guest'] && !isset($_POST['preview']) && $pun_user['last_post'] != '' && (time() - $pun_user['last_post']) < $pun_user['g_post_flood'] && (time() - $pun_user['last_post']) >= 0)
		$errors[] = sprintf($lang_post['Flood'], $pun_user['g_post_flood']);

	// If it's a new topic
	if ($fid)
	{
		$subject = trim($_POST['req_subject']);

		if ($subject == '')
			$errors[] = $lang_post['No subject'];
		else if (pun_strlen($subject) > 70)
			$errors[] = $lang_post['Too long subject'];
		else if ($pun_config['p_subject_all_caps'] == '0' && strtoupper($subject) == $subject && !$pun_user['is_admmod'])
			$subject = ucwords(strtolower($subject));
	}

	// If the user is logged in we get the username and e-mail from $pun_user
	if (!$pun_user['is_guest'])
	{
		$username = $pun_user['username'];
		$email = $pun_user['email'];
	}
	// Otherwise it should be in $_POST
	else
	{
		$username = trim($_POST['req_username']);
		$email = strtolower(trim(($pun_config['p_force_guest_email'] == '1') ? $_POST['req_email'] : $_POST['email']));

		// Load the prof_reg.php/register.php language files
		require PUN_ROOT.'lang/'.$pun_user['language'].'/prof_reg.php';
		require PUN_ROOT.'lang/'.$pun_user['language'].'/register.php';

		// It's a guest, so we have to validate the username
		if (pun_strlen($username) < 2)
			$errors[] = $lang_prof_reg['Username too short'];
		else if (strtolower($username) == 'guest' || strtolower($username) == strtolower($lang_common['Guest']))
			$errors[] = $lang_prof_reg['Username guest'];
		else if (preg_match('/[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}/', $username))
			$errors[] = $lang_prof_reg['Username IP'];

		if ((strpos($username, '[') !== false || strpos($username, ']') !== false) && strpos($username, '\'') !== false && strpos($username, '"') !== false)
			$errors[] = $lang_prof_reg['Username reserved chars'];
		if (preg_match('#\[b\]|\[/b\]|\[u\]|\[/u\]|\[i\]|\[/i\]|\[color|\[/color\]|\[quote\]|\[quote=|\[/quote\]|\[code\]|\[/code\]|\[img\]|\[/img\]|\[url|\[/url\]|\[email|\[/email\]#i', $username))
			$errors[] = $lang_prof_reg['Username BBCode'];

		// Check username for any censored words
		$temp = censor_words($username);
		if ($temp != $username)
			$errors[] = $lang_register['Username censor'];

		// Check that the username (or a too similar username) is not already registered
		$result = $db->query('SELECT username FROM '.$db->prefix.'users WHERE (username=\''.$db->escape($username).'\' OR username=\''.$db->escape(preg_replace('/[^\w]/', '', $username)).'\') AND id>1') or error('Unable to fetch user info', __FILE__, __LINE__, $db->error());
		if ($db->num_rows($result))
		{
			$busy = $db->result($result);
			$errors[] = sprintf($lang_prof_reg['Username dupe'], htmlspecialchars($busy));
		}

		if ($pun_config['p_force_guest_email'] == '1' || $email != '')
		{
			require PUN_ROOT.'include/email.php';
			if (!is_valid_email($email))
				$errors[] = $lang_common['Invalid e-mail'];
		}
	}

	// If we're an administrator or moderator, make sure the CSRF token in $_POST is valid
	if (($pun_user['g_id'] == PUN_ADMIN || $pun_user['g_moderator'] == '1') && $_POST['csrf_token'] !== $pun_user['csrf_token'])
		$errors[] = $lang_post['CSRF token mismatch'];

	// Clean up message from POST
	$message = pun_linebreaks(trim($_POST['req_message']));

	if ($message == '')
		$errors[] = $lang_post['No message'];
	else if (strlen($message) > 65535)
		$errors[] = $lang_post['Too long message'];
	else if ($pun_config['p_message_all_caps'] == '0' && strtoupper($message) == $message && !$pun_user['is_admmod'])
		$message = ucwords(strtolower($message));

	// Validate BBCode syntax
	if ($pun_config['p_message_bbcode'] == '1' && strpos($message, '[') !== false && strpos($message, ']') !== false)
	{
		require PUN_ROOT.'include/parser.php';
		$message = preparse_bbcode($message, $errors);
	}

	if ($db_type != 'mysql' && $db_type != 'mysqli')
		require PUN_ROOT.'include/search_idx.php';

	$hide_smilies = isset($_POST['hide_smilies']) ? 1 : 0;
	$subscribe = isset($_POST['subscribe']) ? 1 : 0;

	$now = time();

	// Did everything go according to plan?
	if (empty($errors) && !isset($_POST['preview']))
	{
		// If it's a reply
		if ($tid)
		{
			if (!$pun_user['is_guest'])
			{
				// Insert the new post
				$db->query('INSERT INTO '.$db->prefix.'posts (poster, poster_id, poster_ip, message, hide_smilies, approved, posted, topic_id) VALUES(\''.$db->escape($username).'\', '.$pun_user['id'].', \''.get_remote_address().'\', \''.$db->escape($message).'\', \''.$hide_smilies.'\', \''.$approved.'\', '.$now.', '.$tid.')') or error('Unable to create post', __FILE__, __LINE__, $db->error());
				$new_pid = $db->insert_id();

				// To subscribe or not to subscribe, that ...
				if ($pun_config['o_subscriptions'] == '1' && $subscribe && !$is_subscribed)
					$db->query('INSERT INTO '.$db->prefix.'subscriptions (user_id, topic_id) VALUES('.$pun_user['id'].' ,'.$tid.')') or error('Unable to add subscription', __FILE__, __LINE__, $db->error());
				// To unsubscribe or not ...
				elseif ($pun_config['o_subscriptions'] == '1' && !$subscribe && $is_subscribed)
					$db->query('DELETE FROM '.$db->prefix.'subscriptions WHERE (topic_id='.$tid.' AND user_id='.$pun_user['id'].')') or error('Unable to remove subscription', __FILE__, __LINE__, $db->error());
			}
			else
			{
				// It's a guest. Insert the new post
				$email_sql = ($pun_config['p_force_guest_email'] == '1' || $email != '') ? '\''.$email.'\'' : 'NULL';
				$db->query('INSERT INTO '.$db->prefix.'posts (poster, poster_ip, poster_email, message, hide_smilies, approved, posted, topic_id) VALUES(\''.$db->escape($username).'\', \''.get_remote_address().'\', '.$email_sql.', \''.$db->escape($message).'\', \''.$hide_smilies.'\', \''.$approved.'\', '.$now.', '.$tid.')') or error('Unable to create post', __FILE__, __LINE__, $db->error());
				$new_pid = $db->insert_id();
			}

			if ($approved == 1)
			{
				// Count number of replies in the topic
				$result = $db->query('SELECT COUNT(id) FROM '.$db->prefix.'posts WHERE topic_id='.$tid) or error('Unable to fetch post count for topic', __FILE__, __LINE__, $db->error());
				$num_replies = $db->result($result, 0) - 1;

				// Update topic
				$db->query('UPDATE '.$db->prefix.'topics SET num_replies='.$num_replies.', last_post='.$now.', last_post_id='.$new_pid.', last_poster=\''.$db->escape($username).'\' WHERE id='.$tid) or error('Unable to update topic', __FILE__, __LINE__, $db->error());

				update_forum($cur_posting['id']);
			}

			if ($db_type != 'mysql' && $db_type != 'mysqli')
				update_search_index('post', $new_pid, $message);

			// Should we send out notifications?
			if ($pun_config['o_subscriptions'] == '1' && $approved == 1)
			{
				// Get the post time for the previous post in this topic
				$result = $db->query('SELECT posted FROM '.$db->prefix.'posts WHERE topic_id='.$tid.' AND approved=1 ORDER BY id DESC LIMIT 1, 1') or error('Unable to fetch post info', __FILE__, __LINE__, $db->error());
				$previous_post_time = $db->result($result);

				// Get any subscribed users that should be notified (banned users are excluded)
				$result = $db->query('SELECT u.id, u.email, u.notify_with_post, u.language FROM '.$db->prefix.'users AS u INNER JOIN '.$db->prefix.'subscriptions AS s ON u.id=s.user_id LEFT JOIN '.$db->prefix.'forum_perms AS fp ON (fp.forum_id='.$cur_posting['id'].' AND fp.group_id=u.group_id) LEFT JOIN '.$db->prefix.'online AS o ON u.id=o.user_id LEFT JOIN '.$db->prefix.'bans AS b ON u.username=b.username WHERE b.username IS NULL AND COALESCE(o.logged, u.last_visit)>'.$previous_post_time.' AND (fp.read_forum IS NULL OR fp.read_forum=1) AND s.topic_id='.$tid.' AND u.id!='.intval($pun_user['id'])) or error('Unable to fetch subscription info', __FILE__, __LINE__, $db->error());
				if ($db->num_rows($result))
				{
					require_once PUN_ROOT.'include/email.php';

					$notification_emails = array();

					// Loop through subscribed users and send e-mails
					while ($cur_subscriber = $db->fetch_assoc($result))
					{
						// Is the subscription e-mail for $cur_subscriber['language'] cached or not?
						if (!isset($notification_emails[$cur_subscriber['language']]))
						{
							if (file_exists(PUN_ROOT.'lang/'.$cur_subscriber['language'].'/mail_templates/new_reply.tpl'))
							{
								// Load the "new reply" template
								$mail_tpl = trim(file_get_contents(PUN_ROOT.'lang/'.$cur_subscriber['language'].'/mail_templates/new_reply.tpl'));

								// Load the "new reply full" template (with post included)
								$mail_tpl_full = trim(file_get_contents(PUN_ROOT.'lang/'.$cur_subscriber['language'].'/mail_templates/new_reply_full.tpl'));

								// The first row contains the subject (it also starts with "Subject:")
								$first_crlf = strpos($mail_tpl, "\n");
								$mail_subject = trim(substr($mail_tpl, 8, $first_crlf-8));
								$mail_message = trim(substr($mail_tpl, $first_crlf));

								$first_crlf = strpos($mail_tpl_full, "\n");
								$mail_subject_full = trim(substr($mail_tpl_full, 8, $first_crlf-8));
								$mail_message_full = trim(substr($mail_tpl_full, $first_crlf));

								$mail_subject = str_replace('<topic_subject>', '\''.$cur_posting['subject'].'\'', $mail_subject);
								$mail_message = str_replace('<topic_subject>', '\''.$cur_posting['subject'].'\'', $mail_message);
								$mail_message = str_replace('<replier>', $username, $mail_message);
								$mail_message = str_replace('<post_url>', pun_link($pun_url['post'], $new_pid), $mail_message);
								$mail_message = str_replace('<unsubscribe_url>', pun_link($pun_url['unsubscribe'], $tid), $mail_message);
								$mail_message = str_replace('<board_mailer>', sprintf($lang_common['Forum mailer'], $pun_config['o_board_title']), $mail_message);

								$mail_subject_full = str_replace('<topic_subject>', '\''.$cur_posting['subject'].'\'', $mail_subject_full);
								$mail_message_full = str_replace('<topic_subject>', '\''.$cur_posting['subject'].'\'', $mail_message_full);
								$mail_message_full = str_replace('<replier>', $username, $mail_message_full);
								$mail_message_full = str_replace('<message>', $message, $mail_message_full);
								$mail_message_full = str_replace('<post_url>', pun_link($pun_url['post'], $new_pid), $mail_message_full);
								$mail_message_full = str_replace('<unsubscribe_url>', pun_link($pun_url['unsubscribe'], $tid), $mail_message_full);
								$mail_message_full = str_replace('<board_mailer>', sprintf($lang_common['Forum mailer'], $pun_config['o_board_title']), $mail_message_full);

								$notification_emails[$cur_subscriber['language']][0] = $mail_subject;
								$notification_emails[$cur_subscriber['language']][1] = $mail_message;
								$notification_emails[$cur_subscriber['language']][2] = $mail_subject_full;
								$notification_emails[$cur_subscriber['language']][3] = $mail_message_full;

								$mail_subject = $mail_message = $mail_subject_full = $mail_message_full = null;
							}
						}

						// We have to double check here because the templates could be missing
						if (isset($notification_emails[$cur_subscriber['language']]))
						{
							// Make sure the e-mail address format is valid before sending
							if (is_valid_email($cur_subscriber['email']))
							{
								if ($cur_subscriber['notify_with_post'] == '0')
									pun_mail($cur_subscriber['email'], $notification_emails[$cur_subscriber['language']][0], $notification_emails[$cur_subscriber['language']][1]);
								else
									pun_mail($cur_subscriber['email'], $notification_emails[$cur_subscriber['language']][2], $notification_emails[$cur_subscriber['language']][3]);
							}
						}
					}
				}
			}
		}
		// If it's a new topic
		else if ($fid)
		{
			// Create the topic
			$db->query('INSERT INTO '.$db->prefix.'topics (poster, subject, posted, last_post, last_poster, forum_id) VALUES(\''.$db->escape($username).'\', \''.$db->escape($subject).'\', '.$now.', '.$now.', \''.$db->escape($username).'\', '.$fid.')') or error('Unable to create topic', __FILE__, __LINE__, $db->error());
			$new_tid = $db->insert_id();

			if (!$pun_user['is_guest'])
			{
				// To subscribe or not to subscribe, that ...
				if ($pun_config['o_subscriptions'] == '1' && (isset($_POST['subscribe']) && $_POST['subscribe'] == '1'))
					$db->query('INSERT INTO '.$db->prefix.'subscriptions (user_id, topic_id) VALUES('.$pun_user['id'].' ,'.$new_tid.')') or error('Unable to add subscription', __FILE__, __LINE__, $db->error());

				// Create the post ("topic post")
				$db->query('INSERT INTO '.$db->prefix.'posts (poster, poster_id, poster_ip, message, hide_smilies, approved, posted, topic_id) VALUES(\''.$db->escape($username).'\', '.$pun_user['id'].', \''.get_remote_address().'\', \''.$db->escape($message).'\', \''.$hide_smilies.'\', \''.$approved.'\', '.$now.', '.$new_tid.')') or error('Unable to create post', __FILE__, __LINE__, $db->error());
			}
			else
			{
				// Create the post ("topic post")
				$email_sql = ($pun_config['p_force_guest_email'] == '1' || $email != '') ? '\''.$email.'\'' : 'NULL';
				$db->query('INSERT INTO '.$db->prefix.'posts (poster, poster_ip, poster_email, message, hide_smilies, approved, posted, topic_id) VALUES(\''.$db->escape($username).'\', \''.get_remote_address().'\', '.$email_sql.', \''.$db->escape($message).'\', \''.$hide_smilies.'\', \''.$approved.'\', '.$now.', '.$new_tid.')') or error('Unable to create post', __FILE__, __LINE__, $db->error());
			}
			$new_pid = $db->insert_id();

			// Update the topic with last_post_id
			$db->query('UPDATE '.$db->prefix.'topics SET last_post_id='.$new_pid.' WHERE id='.$new_tid) or error('Unable to update topic', __FILE__, __LINE__, $db->error());

			if ($db_type != 'mysql' && $db_type != 'mysqli')
				update_search_index('post', $new_pid, $message, $subject);

			update_forum($fid);
		}

		if (!$pun_user['is_guest'])
		{
			// If the posting user is logged in, increment his/her post count
			$low_prio = ($db_type == 'mysql') ? 'LOW_PRIORITY ' : '';
			$db->query('UPDATE '.$low_prio.$db->prefix.'users SET num_posts=num_posts+1, last_post='.$now.' WHERE id='.$pun_user['id']) or error('Unable to update user', __FILE__, __LINE__, $db->error());

			// Add/update the topic in our list of tracked topics
			$tracked_topics = get_tracked_topics();
			$tracked_topics[$tid ? $tid : $new_tid] = time();
			set_tracked_topics($tracked_topics);
		}

		if ($pun_user['is_guest'])
		{
			if ($fid)
				redirect(pun_link($pun_url['forum'], $fid), $lang_post['Post redirect']);
			else
				redirect(pun_link($pun_url['topic'], $tid ? $tid : $new_tid), $lang_post['Post redirect']);
		}
		else
			redirect(pun_link($pun_url['post'], $new_pid), $lang_post['Post redirect']);
	}
}


// Are we quoting someone?
if ($tid && isset($_GET['qid']))
{
	$qid = intval($_GET['qid']);
	if ($qid < 1)
		message($lang_common['Bad request']);

	$result = $db->query('SELECT poster, message FROM '.$db->prefix.'posts WHERE approved=1 AND id='.$qid.' AND topic_id='.$tid) or error('Unable to fetch quote info', __FILE__, __LINE__, $db->error());
	if (!$db->num_rows($result))
		message($lang_common['Bad request']);

	list($q_poster, $q_message) = $db->fetch_row($result);

	$q_message = str_replace('[img]', '[url]', $q_message);
	$q_message = str_replace('[/img]', '[/url]', $q_message);
	$q_message = htmlspecialchars($q_message);

	if ($pun_config['p_message_bbcode'] == '1')
	{
		// If username contains a square bracket, we add "" or '' around it (so we know when it starts and ends)
		if (strpos($q_poster, '[') !== false || strpos($q_poster, ']') !== false)
		{
			if (strpos($q_poster, '\'') !== false)
				$q_poster = '"'.$q_poster.'"';
			else
				$q_poster = '\''.$q_poster.'\'';
		}
		else
		{
			// Get the characters at the start and end of $q_poster
			$ends = substr($q_poster, 0, 1).substr($q_poster, -1, 1);

			// Deal with quoting "Username" or 'Username' (becomes '"Username"' or "'Username'")
			if ($ends == '\'\'')
				$q_poster = '"'.$q_poster.'"';
			else if ($ends == '""')
				$q_poster = '\''.$q_poster.'\'';
		}

		$quote = '[quote='.$q_poster.']'.$q_message.'[/quote]'."\n";
	}
	else
		$quote = '> '.sprintf($lang_common['User wrote'], $q_poster).':'."\n\n".'> '.$q_message."\n";
}


// Setup breadcrumbs
$pun_page['crumbs'][] = array($pun_config['o_board_title'], pun_link($pun_url['index']));
$pun_page['crumbs'][] = array($cur_posting['forum_name'], pun_link($pun_url['forum'], $cur_posting['id']));
if ($tid) $pun_page['crumbs'][] = array($cur_posting['subject'], pun_link($pun_url['topic'], $tid));
$pun_page['crumbs'][] = $tid ? $lang_post['Post reply'] : $lang_post['Post new topic'];

define('PUN_PAGE', 'post');
require PUN_ROOT.'header.php';

?>
<div id="pun-main1" class="a-section a-main">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

	<div class="b-postform">
		<div class="c-section c-form">
<?php

// If preview selected and there are no errors
if (isset($_POST['preview']) && empty($errors))
{
	require_once PUN_ROOT.'include/parser.php';
	$preview_message = parse_message(trim($_POST['req_message']), $hide_smilies);

?>
			<div class="panel">
				<div class="form-intro">
					<h2><span><?php echo $lang_post['Post preview'] ?></span></h2>
				</div>
				<div class="post-entry">
					<div class="entry-content">
					<?php echo $preview_message."\n" ?>
					</div>
				</div>
			</div>
			<div class="divider"><hr /></div>
<?php

}

?>
			<form id="afocus" method="post" accept-charset="utf-8" action="<?php echo $tid ? pun_link($pun_url['new_reply'], $tid) : pun_link($pun_url['new_topic'], $fid) ?>">
			<div class="panel">

<?php

// Setup post help/navigation links
$post_help = array();

if ($tid && $pun_config['o_topic_review'] != '0') $post_help[] = '<li><a href="#pun-main3">'.$lang_post['Skip to review'].'</a></li>';
if ($pun_config['p_message_bbcode'] == '1') $post_help[] = '<li><a href="'.pun_link($pun_url['help'], 'bbcode').'" onclick="window.open(this.href); return false;" title="'.$lang_common['New window warn'].'">'.$lang_common['BBCode help'].'</a></li>';
if ($pun_config['p_message_img_tag'] == '1') $post_help[] = '<li><a href="'.pun_link($pun_url['help'], 'img').'" onclick="window.open(this.href); return false;" title="'.$lang_common['New window warn'].'">'.$lang_common['img tag help'].'</a></li>';
if ($pun_config['o_smilies'] == '1') $post_help[] = '<li><a href="'.pun_link($pun_url['help'], 'smilies').'" onclick="window.open(this.href); return false;" title="'.$lang_common['New window warn'].'">'.$lang_common['Smilies help'].'</a></li>';

if (!empty($post_help))
{

?>
				<div class="form-intro">
					<ul class="optionlist">
						<?php echo implode("\n\t\t\t\t\t\t", $post_help)."\n" ?>
					</ul>
				</div>
<?php

}

if ($pun_user['is_admmod'])
	echo "\t\t\t\t".'<input type="hidden" name="csrf_token" value="'.$pun_user['csrf_token'].'" />'."\n";

// Display any errors
if (!empty($errors))
{

?>
				<div class="form-warn">
					<p><strong><?php echo $lang_common['Warning'] ?></strong> <?php echo $lang_post['Post errors'] ?></p>
					<ul class="warnlist">
<?php

	while (list(, $cur_error) = each($errors))
		echo "\t\t\t\t\t\t".'<li><span>'.$cur_error.'</span></li>'."\n";

?>
					</ul>
				</div>
<?php

}

$fld_count = 0;

?>
				<p id="req-msg" class="req-warn"><?php printf($lang_common['Required warn'], '<em class="req-text">'.$lang_common['Required mark'].'<span> '.$lang_common['Required'].'</span></em>') ?></p>
				<fieldset>
					<legend><span><?php echo $lang_common['Write message legend'] ?></span></legend>
					<input type="hidden" name="form_sent" value="1" />
					<input type="hidden" name="form_user" value="<?php echo (!$pun_user['is_guest']) ? htmlspecialchars($pun_user['username']) : 'Guest'; ?>" />
<?php

if ($pun_user['is_guest'])
{
	$email_form_name = ($pun_config['p_force_guest_email'] == '1') ? 'req_email' : 'email';

?>
					<p class="field required">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo $lang_post['Guest name'] ?> <em class="req-text"><?php echo $lang_common['Required mark'].' <span>'.$lang_common['Required'].'</span>' ?></em></label><br />
						<span class="input"><input type="text" id="fld<?php echo $fld_count ?>" name="req_username" value="<?php if (isset($_POST['req_username'])) echo htmlspecialchars($username); ?>" size="25" maxlength="25" /></span>
					</p>
					<p class="field<?php if ($pun_config['p_force_guest_email'] == '1') echo ' required' ?>">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo $lang_common['E-mail']; if ($pun_config['p_force_guest_email'] == '1') echo ' <em class="req-text">'.$lang_common['Required mark'].' <span>'.$lang_common['Required'].'</span></em>' ?></label><br />
						<span class="input"><input type="text" id="fld<?php echo $fld_count ?>" name="<?php echo $email_form_name ?>" value="<?php if (isset($_POST[$email_form_name])) echo htmlspecialchars($email); ?>" size="50" maxlength="80" /></span>
					</p>
<?php

}

if ($fid)
{

?>
					<p class="longfield required">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo $lang_common['Subject'] ?> <em class="req-text"><?php echo $lang_common['Required mark'].' <span>'.$lang_common['Required'].'</span>' ?></em></label><br />
						<span class="input"><input id="fld<?php echo $fld_count ?>" type="text" name="req_subject" value="<?php if (isset($_POST['req_subject'])) echo htmlspecialchars($subject); ?>" size="80" maxlength="70" /></span>
					</p>
<?php

}

?>
					<p id="compose" class="areafield required">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo $lang_common['Message'] ?> <em class="req-text"><?php echo $lang_common['Required mark'].' <span>'.$lang_common['Required'].'</span>' ?></em></label><br />
						<span class="input"><textarea id="fld<?php echo $fld_count ?>" name="req_message" rows="20" cols="95"><?php echo isset($_POST['req_message']) ? htmlspecialchars($message) : (isset($quote) ? $quote : ''); ?></textarea></span>
					</p>
<?php

$checkboxes = array();
if ($pun_config['o_smilies'] == '1')
	$checkboxes[] = '<span class="input"><input type="checkbox" id="fld'.(++$fld_count).'" name="hide_smilies" value="1"'.(isset($_POST['hide_smilies']) ? ' checked="checked"' : '').' /> <label for="fld'.$fld_count.'">'.$lang_post['Hide smilies'].'</label></span><br />';

// Check/uncheck the checkbox for subscriptions depending on scenario
if (!$pun_user['is_guest'] && $pun_config['o_subscriptions'] == '1')
{
	$checked = false;

	// If it's a preview
	if (isset($_POST['preview']))
		$checked = isset($_POST['subscribe']) ? true : false;
	// If auto subscribed
	else if ($pun_user['auto_notify'])
		$checked = true;
	// If already subscribed to the topic
	else if ($is_subscribed)
		$checked = true;

	$checkboxes[] = '<span class="input"><input type="checkbox" id="fld'.(++$fld_count).'" name="subscribe" value="1"'.($checked ? ' checked="checked"' : '').' /> <label for="flf'.$fld_count.'">'.($is_subscribed ? $lang_post['Stay subscribed'] : $lang_post['Subscribe']).'</label></span><br />';
}

if (!empty($checkboxes))
{

?>
					<fieldset class="checkset">
						<legend><span><?php echo $lang_post['Post options'] ?></span></legend>
						<?php echo implode("\n\t\t\t\t\t\t", $checkboxes)."\n"; ?>
					</fieldset>
				</fieldset>
<?php

}

if ($approved == 0)
{

?>
				<div class="form-warn">
					<p><strong><?php echo $lang_common['Warning'] ?></strong> <?php echo $pun_user['is_guest'] ? $lang_common['Approval guest warning'] : $lang_common['Approval warning'] ?></p>
				</div>
<?php

}

?>
				<p class="formsubmit"><input type="submit" class="button" name="submit" value="<?php echo $lang_common['Submit'] ?>" accesskey="s" title="<?php echo $lang_common['Submit title'] ?>" /> <input type="submit" class="button" name="preview" value="<?php echo $lang_post['Preview'] ?>" accesskey="p" title="<?php echo $lang_post['Preview title'] ?>" /></p>
			</div>
			</form>
		</div>
	</div>

</div>
<?php


// Check if the topic review is to be displayed
if ($tid && $pun_config['o_topic_review'] != '0')
{
	require_once PUN_ROOT.'include/parser.php';

	$result = $db->query('SELECT id, poster, message, hide_smilies, posted FROM '.$db->prefix.'posts WHERE topic_id='.$tid.' ORDER BY id DESC LIMIT '.$pun_config['o_topic_review']) or error('Unable to fetch topic review', __FILE__, __LINE__, $db->error());

?>
<div id="pun-main2" class="a-section a-main">

	<h2 class="main-title"><span><?php echo $lang_post['Topic review'] ?></span></h2>

	<div class="b-section b-topic">
<?php

	$post_count = 0;

	while ($cur_post = $db->fetch_assoc($result))
	{
		++$post_count;
		$post_class = 'post';

		$cur_post['message'] = parse_message($cur_post['message'], $cur_post['hide_smilies']);

?>
		<div class="post">
			<div class="posthead">
				<h3><strong><?php echo $post_count ?></strong> <cite class="author"><span><?php echo $lang_common['Posted by'] ?></span> <em><?php echo $cur_post['poster'] ?></em></cite> <abbr class="published" title="<?php echo date("Y-m-d\Th:i:s\Z", $cur_post['posted']) ?>"><a class="permalink" rel="bookmark" title="<?php echo $lang_post['Permalink post'] ?>" href="<?php echo pun_link($pun_url['post'], $cur_post['id']) ?>"><?php echo format_time($cur_post['posted']) ?></a></abbr></h3>
			</div>
			<div class="postmain">
				<div class="postbody">
					<div class="post-entry">
						<div class="entry-content">
						<?php echo $cur_post['message']."\n" ?>
						</div>
					</div>
				</div>
			</div>
		</div>
<?php

	}

?>
	</div>

</div>
<?php

}

require PUN_ROOT.'footer.php';
