<?php
/***********************************************************************

  Copyright (C) 2002-2007  Rickard Andersson (rickard@punbb.org)

  This file is part of PunBB.

  PunBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/


define('PUN_ROOT', './');
require PUN_ROOT.'include/common.php';


$action = isset($_GET['action']) ? $_GET['action'] : null;
$section = isset($_GET['section']) ? $_GET['section'] : null;
$id = isset($_GET['id']) ? intval($_GET['id']) : 0;
if ($id < 2)
	message($lang_common['Bad request']);

if ($action != 'change_pass' || !isset($_GET['key']))
{
	if ($pun_user['g_read_board'] == '0')
		message($lang_common['No view']);
	else if ($pun_user['g_view_users'] == '0' && ($pun_user['is_guest'] || $pun_user['id'] != $id))
		message($lang_common['No permission']);
}

// Load the profile.php/register.php language file
require PUN_ROOT.'lang/'.$pun_user['language'].'/prof_reg.php';

// Load the profile.php language file
require PUN_ROOT.'lang/'.$pun_user['language'].'/profile.php';


// Fetch info about the user whose profile we're viewing
$query = array(
	'SELECT'	=> 'u.*, g.g_id, g.g_user_title, g.g_moderator',
	'FROM'		=> 'users AS u',
	'JOINS'		=> array(
		array(
			'LEFT JOIN'	=> 'groups AS g',
			'ON'		=> 'g.g_id=u.group_id'
		)
	),
	'WHERE'		=> 'u.id='.$id
);

$result = $db->query_build($query) or error('Unable to fetch user info', __FILE__, __LINE__, $db->error());
if (!$db->num_rows($result))
	message($lang_common['Bad request']);

$user = $db->fetch_assoc($result);


if ($action == 'change_pass')
{
	if (isset($_GET['key']))
	{
		// If the user is already logged in we shouldn't be here :)
		if (!$pun_user['is_guest'])
		{
			message($lang_profile['Pass logout']);
			exit;
		}

		$key = $_GET['key'];

		if ($key == '' || $key != $user['activate_key'])
			message(sprintf($lang_profile['Pass key bad'], '<a href="mailto:'.$pun_config['o_admin_email'].'">'.$pun_config['o_admin_email'].'</a>'));
		else
		{
			$db->query('UPDATE '.$db->prefix.'users SET password=activate_string, activate_string=NULL, activate_key=NULL WHERE id='.$id) or error('Unable to update password', __FILE__, __LINE__, $db->error());

			message($lang_profile['Pass updated']);
		}
	}

	// Make sure we are allowed to change this user's password
	if ($pun_user['id'] != $id &&
		$pun_user['g_id'] != PUN_ADMIN &&
		($pun_user['g_moderator'] != '1' || $pun_config['p_mod_edit_users'] == '0' || $pun_config['p_mod_change_passwords'] == '0' || $user['g_id'] == PUN_ADMIN || $user['g_moderator'] == '1'))
		message($lang_common['No permission']);

	if (isset($_POST['form_sent']))
	{
		$old_password = isset($_POST['req_old_password']) ? trim($_POST['req_old_password']) : '';
		$new_password1 = trim($_POST['req_new_password1']);
		$new_password2 = trim($_POST['req_new_password2']);

		if ($new_password1 != $new_password2)
			message($lang_prof_reg['Pass not match']);
		if (pun_strlen($new_password1) < 4)
			message($lang_prof_reg['Pass too short']);

		$authorized = false;
		if (!empty($user['password']))
		{
			$old_password_hash = sha1($user['salt'].sha1($old_password));

			if (($user['password'] == $old_password_hash) || $pun_user['is_admmod'])
				$authorized = true;
		}

		if (!$authorized)
			message($lang_profile['Wrong pass']);

		$new_password_hash = sha1($user['salt'].sha1($new_password1));

		$db->query('UPDATE '.$db->prefix.'users SET password=\''.$new_password_hash.'\' WHERE id='.$id) or error('Unable to update password', __FILE__, __LINE__, $db->error());

		if ($pun_user['id'] == $id)
		{
			$expire = ($user['save_pass'] == '1') ? time() + 31536000 : 0;
			pun_setcookie($pun_user['id'], $new_password_hash, $expire);
		}

		redirect(pun_link($pun_url['profile_identity'], $id), $lang_profile['Pass updated redirect']);
	}


	// Setup breadcrumbs
	$pun_page['crumbs'] = array(
		array($pun_config['o_board_title'], pun_link($pun_url['index'])),
		array(sprintf($lang_profile['Users profile'], htmlspecialchars($user['username']), $lang_profile['Section identity']), pun_link($pun_url['profile_identity'], $id)),
		$lang_profile['Change pass']
	);

	define('PUN_PAGE', 'dialogue');
	require PUN_ROOT.'header.php';

	$fld_count = 0;

?>
<div id="pun-main1" class="a-section a-main">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

	<div class="b-section b-dataform">
		<div class="c-section c-form">
			<form id="afocus" method="post" accept-charset="utf-8" action="<?php echo pun_link($pun_url['change_password'], $id) ?>">
			<div class="panel">
<?php if ($pun_user['is_admmod']): ?>				<input type="hidden" name="csrf_token" value="<?php echo $pun_user['csrf_token'] ?>" />
<?php endif; ?>				<input type="hidden" name="form_sent" value="1" />
				<p id="req-msg" class="req-warn"><?php printf($lang_common['Required warn'], '<em class="req-text">'.$lang_common['Required mark'].'<span> '.$lang_common['Required'].'</span></em>') ?></p>
				<div class="textset">
<?php if (!$pun_user['is_admmod']): ?>					<p class="field required">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo $lang_profile['Old pass'] ?> <em class="req-text"><?php echo $lang_common['Required mark'].' <span>'.$lang_common['Required'].'</span>' ?></em></label><br />
						<span class="input"><input type="password" id="fld<?php echo $fld_count ?>" name="req_old_password" size="16" /> <em><?php echo $lang_profile['Old pass info'] ?></em></span>
					</p>
<?php endif; ?>					<p class="field required">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo $lang_profile['New pass'] ?> <em class="req-text"><?php echo $lang_common['Required mark'].' <span>'.$lang_common['Required'].'</span>' ?></em></label><br />
						<span class="input"><input type="password" id="fld<?php echo $fld_count ?>" name="req_new_password1" size="16" /> <em><?php echo $lang_prof_reg['Pass info'] ?></em></span>
					</p>
					<p class="field required">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo $lang_profile['Re-enter new pass'] ?> <em class="req-text"><?php echo $lang_common['Required mark'].' <span>'.$lang_common['Required'].'</span>' ?></em></label><br />
						<span class="input"><input type="password" id="fld<?php echo $fld_count ?>" name="req_new_password2" size="16" /> <em><?php echo $lang_prof_reg['Confirm pass info'] ?></em></span>
					</p>
				</div>
				<p class="formsubmit"><input type="submit" class="button" name="update" value="<?php echo $lang_common['Submit'] ?>" /></p>
			</div>
			</form>
		</div>
	</div>

</div>
<?php

	require PUN_ROOT.'footer.php';
}


else if ($action == 'change_email')
{
	// Make sure we are allowed to change this user's e-mail
	if ($pun_user['id'] != $id &&
		$pun_user['g_id'] != PUN_ADMIN &&
		($pun_user['g_moderator'] != '1' || $pun_config['p_mod_edit_users'] == '0' || $user['g_id'] == PUN_ADMIN || $user['g_moderator'] == '1'))
		message($lang_common['No permission']);

	if (isset($_GET['key']))
	{
		$key = $_GET['key'];

		if ($key != $user['activate_key'])
			message(sprintf($lang_profile['E-mail key bad'], '<a href="mailto:'.$pun_config['o_admin_email'].'">'.$pun_config['o_admin_email'].'</a>'));
		else
		{
			$db->query('UPDATE '.$db->prefix.'users SET email=activate_string, activate_string=NULL, activate_key=NULL WHERE id='.$id) or error('Unable to update e-mail address', __FILE__, __LINE__, $db->error());

			message($lang_profile['E-mail updated']);
		}
	}
	else if (isset($_POST['form_sent']))
	{
		if (sha1($_POST['req_password']) !== $pun_user['password'])
			message($lang_profile['Wrong pass']);

		require PUN_ROOT.'include/email.php';

		// Validate the email-address
		$new_email = strtolower(trim($_POST['req_new_email']));
		if (!is_valid_email($new_email))
			message($lang_common['Invalid e-mail']);

		// Check it it's a banned e-mail address
		if (is_banned_email($new_email))
		{
			if ($pun_config['p_allow_banned_email'] == '0')
				message($lang_prof_reg['Banned e-mail']);
			else if ($pun_config['o_mailing_list'] != '')
			{
				$mail_subject = 'Alert - Banned e-mail detected';
				$mail_message = 'User \''.$pun_user['username'].'\' changed to banned e-mail address: '.$new_email."\n\n".'User profile: '.pun_link($pun_url['user'], $id)."\n\n".'-- '."\n".'Forum Mailer'."\n".'(Do not reply to this message)';

				pun_mail($pun_config['o_mailing_list'], $mail_subject, $mail_message);
			}
		}

		// Check if someone else already has registered with that e-mail address
		$result = $db->query('SELECT id, username FROM '.$db->prefix.'users WHERE email=\''.$db->escape($new_email).'\'') or error('Unable to fetch user info', __FILE__, __LINE__, $db->error());
		if ($db->num_rows($result))
		{
			if ($pun_config['p_allow_dupe_email'] == '0')
				message($lang_prof_reg['Dupe e-mail']);
			else if ($pun_config['o_mailing_list'] != '')
			{
				while ($cur_dupe = $db->fetch_assoc($result))
					$dupe_list[] = $cur_dupe['username'];

				$mail_subject = 'Alert - Duplicate e-mail detected';
				$mail_message = 'User \''.$pun_user['username'].'\' changed to an e-mail address that also belongs to: '.implode(', ', $dupe_list)."\n\n".'User profile: '.pun_link($pun_url['user'], $id)."\n\n".'-- '."\n".'Forum Mailer'."\n".'(Do not reply to this message)';

				pun_mail($pun_config['o_mailing_list'], $mail_subject, $mail_message);
			}
		}

		$new_email_key = random_key(8, true);

		$db->query('UPDATE '.$db->prefix.'users SET activate_string=\''.$db->escape($new_email).'\', activate_key=\''.$new_email_key.'\' WHERE id='.$id) or error('Unable to update activation data', __FILE__, __LINE__, $db->error());

		// Load the "activate e-mail" template
		$mail_tpl = trim(file_get_contents(PUN_ROOT.'lang/'.$pun_user['language'].'/mail_templates/activate_email.tpl'));

		// The first row contains the subject
		$first_crlf = strpos($mail_tpl, "\n");
		$mail_subject = trim(substr($mail_tpl, 8, $first_crlf-8));
		$mail_message = trim(substr($mail_tpl, $first_crlf));

		$mail_message = str_replace('<username>', $pun_user['username'], $mail_message);
		$mail_message = str_replace('<base_url>', $base_url.'/', $mail_message);
		$mail_message = str_replace('<activation_url>', pun_link($pun_url['change_email_key'], array($id, $new_email_key)), $mail_message);
		$mail_message = str_replace('<board_mailer>', sprintf($lang_common['Forum mailer'], $pun_config['o_board_title']), $mail_message);

		pun_mail($new_email, $mail_subject, $mail_message);

		message(sprintf($lang_profile['Activate e-mail sent'], '<a href="mailto:'.$pun_config['o_admin_email'].'">'.$pun_config['o_admin_email'].'</a>'));
	}


	// Setup breadcrumbs
	$pun_page['crumbs'] = array(
		array($pun_config['o_board_title'], pun_link($pun_url['index'])),
		array(sprintf($lang_profile['Users profile'], htmlspecialchars($user['username']), $lang_profile['Section identity']), pun_link($pun_url['profile_identity'], $id)),
		$lang_profile['Change e-mail']
	);

	define('PUN_PAGE', 'dialogue');
	require PUN_ROOT.'header.php';

	$fld_count = 0;

?>
<div id="pun-main1" class="a-section a-main">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

	<div class="b-section b-dataform">
		<div class="c-section c-form">
			<form id="afocus" method="post" accept-charset="utf-8" action="<?php echo pun_link($pun_url['change_email'], $id) ?>">
			<div class="panel">
<?php if ($pun_user['is_admmod']): ?>				<input type="hidden" name="csrf_token" value="<?php echo $pun_user['csrf_token'] ?>" />
<?php endif; ?>				<input type="hidden" name="form_sent" value="1" />
				<p id="req-msg" class="req-warn"><?php printf($lang_common['Required warn'], '<em class="req-text">'.$lang_common['Required mark'].'<span> '.$lang_common['Required'].'</span></em>') ?></p>
				<div class="textset" id="fs1">
					<p class="field required">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo $lang_profile['New e-mail'] ?> <em class="req-text"><?php echo $lang_common['Required mark'].' <span>'.$lang_common['Required'].'</span>' ?></em></label><br />
						<span class="input"><input type="text" id="fld<?php echo $fld_count ?>" name="req_new_email" size="50" maxlength="80" /></span>
					</p>
					<p class="field required">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo $lang_common['Password'] ?> <em class="req-text"><?php echo $lang_common['Required mark'].' <span>'.$lang_common['Required'].'</span>' ?></em></label><br />
						<span class="input"><input type="text" id="fld<?php echo $fld_count ?>" name="req_password" size="16" /></span>
					</p>
				</div>
				<div class="form-warn">
					<p><strong><?php echo $lang_common['Important'] ?></strong> <?php echo $lang_profile['E-mail instructions'] ?></p>
				</div>
				<p class="formsubmit"><input type="submit" class="button" name="new_email" value="<?php echo $lang_common['Submit'] ?>" /></p>
			</div>
			</form>
		</div>
	</div>

</div>
<?php

	require PUN_ROOT.'footer.php';
}


else if ($action == 'delete_avatar')
{
	// Make sure we are allowed to delete this user's avatar
	if ($pun_user['id'] != $id &&
		$pun_user['g_id'] != PUN_ADMIN &&
		($pun_user['g_moderator'] != '1' || $pun_config['p_mod_edit_users'] == '0' || $user['g_id'] == PUN_ADMIN || $user['g_moderator'] == '1'))
		message($lang_common['No permission']);

	@unlink($pun_config['o_avatars_dir'].'/'.$id.'.jpg');
	@unlink($pun_config['o_avatars_dir'].'/'.$id.'.png');
	@unlink($pun_config['o_avatars_dir'].'/'.$id.'.gif');

	redirect(pun_link($pun_url['profile_avatar'], $id), $lang_profile['Avatar deleted redirect']);
}


else if (isset($_POST['update_group_membership']))
{
	if ($pun_user['g_id'] != PUN_ADMIN)
		message($lang_common['No permission']);

	$new_group_id = intval($_POST['group_id']);

	$db->query('UPDATE '.$db->prefix.'users SET group_id='.$new_group_id.' WHERE id='.$id) or error('Unable to change user group', __FILE__, __LINE__, $db->error());

	$result = $db->query('SELECT g_moderator FROM '.$db->prefix.'groups WHERE g_id = '.$new_group_id) or error('Unable to fetch user group', __FILE__, __LINE__, $db->error());
	$new_group_mod = $db->result($result);

	// If the user was a moderator or an administrator, we remove him/her from the moderator list in all forums
	if (($user['g_id'] == PUN_ADMIN || $user['g_moderator'] == '1') && $new_group_id != PUN_ADMIN && $new_group_mod != '1')
	{
		$result = $db->query('SELECT id, moderators FROM '.$db->prefix.'forums') or error('Unable to fetch forum list', __FILE__, __LINE__, $db->error());

		while ($cur_forum = $db->fetch_assoc($result))
		{
			$cur_moderators = ($cur_forum['moderators'] != '') ? unserialize($cur_forum['moderators']) : array();

			if (in_array($id, $cur_moderators))
			{
				$username = array_search($id, $cur_moderators);
				unset($cur_moderators[$username]);
				$cur_moderators = (!empty($cur_moderators)) ? '\''.$db->escape(serialize($cur_moderators)).'\'' : 'NULL';

				$db->query('UPDATE '.$db->prefix.'forums SET moderators='.$cur_moderators.' WHERE id='.$cur_forum['id']) or error('Unable to update forum', __FILE__, __LINE__, $db->error());
			}
		}
	}

	redirect(pun_link($pun_url['profile_admin'], $id), $lang_profile['Group membership redirect']);
}


else if (isset($_POST['update_forums']))
{
	if ($pun_user['g_id'] != PUN_ADMIN)
		message($lang_common['No permission']);

	$moderator_in = (isset($_POST['moderator_in'])) ? array_keys($_POST['moderator_in']) : array();

	// Loop through all forums
	$result = $db->query('SELECT id, moderators FROM '.$db->prefix.'forums') or error('Unable to fetch forum list', __FILE__, __LINE__, $db->error());

	while ($cur_forum = $db->fetch_assoc($result))
	{
		$cur_moderators = ($cur_forum['moderators'] != '') ? unserialize($cur_forum['moderators']) : array();
		// If the user should have moderator access (and he/she doesn't already have it)
		if (in_array($cur_forum['id'], $moderator_in) && !in_array($id, $cur_moderators))
		{
			$cur_moderators[$user['username']] = $id;
			ksort($cur_moderators);

			$db->query('UPDATE '.$db->prefix.'forums SET moderators=\''.$db->escape(serialize($cur_moderators)).'\' WHERE id='.$cur_forum['id']) or error('Unable to update forum', __FILE__, __LINE__, $db->error());
		}
		// If the user shouldn't have moderator access (and he/she already has it)
		else if (!in_array($cur_forum['id'], $moderator_in) && in_array($id, $cur_moderators))
		{
			unset($cur_moderators[$user['username']]);
			$cur_moderators = (!empty($cur_moderators)) ? '\''.$db->escape(serialize($cur_moderators)).'\'' : 'NULL';

			$db->query('UPDATE '.$db->prefix.'forums SET moderators='.$cur_moderators.' WHERE id='.$cur_forum['id']) or error('Unable to update forum', __FILE__, __LINE__, $db->error());
		}
	}

	redirect(pun_link($pun_url['profile_admin'], $id), $lang_profile['Update forums redirect']);
}


else if (isset($_POST['ban']))
{
	if ($pun_user['g_id'] != PUN_ADMIN && ($pun_user['g_moderator'] != '1' || $pun_config['p_mod_ban_users'] == '0'))
		message($lang_common['No permission']);

	redirect(pun_link($pun_url['admin_bans']).'?add_ban='.$id, $lang_profile['Ban redirect']);
}


else if (isset($_POST['delete_user']) || isset($_POST['delete_user_comply']) || isset($_POST['delete_user_cancel']))
{
	// User pressed the cancel button
	if (isset($_POST['delete_user_cancel']))
		redirect(pun_link($pun_url['profile_admin'], $id), $lang_common['Cancel redirect']);


	if ($pun_user['g_id'] != PUN_ADMIN)
		message($lang_common['No permission']);

	if ($user['g_id'] == PUN_ADMIN)
		message('Administrators cannot be deleted. In order to delete this user, you must first move him/her to a different user group.');

	if (isset($_POST['delete_user_comply']))
	{
		// If the user is a moderator or an administrator, we remove him/her from the moderator list in all forums
		if ($user['g_id'] == PUN_ADMIN || $user['g_moderator'] == '1')
		{
			$result = $db->query('SELECT id, moderators FROM '.$db->prefix.'forums') or error('Unable to fetch forum list', __FILE__, __LINE__, $db->error());

			while ($cur_forum = $db->fetch_assoc($result))
			{
				$cur_moderators = ($cur_forum['moderators'] != '') ? unserialize($cur_forum['moderators']) : array();

				if (in_array($id, $cur_moderators))
				{
					unset($cur_moderators[$username]);
					$cur_moderators = (!empty($cur_moderators)) ? '\''.$db->escape(serialize($cur_moderators)).'\'' : 'NULL';

					$db->query('UPDATE '.$db->prefix.'forums SET moderators='.$cur_moderators.' WHERE id='.$cur_forum['id']) or error('Unable to update forum', __FILE__, __LINE__, $db->error());
				}
			}
		}

		// Delete any subscriptions
		$db->query('DELETE FROM '.$db->prefix.'subscriptions WHERE user_id='.$id) or error('Unable to delete subscriptions', __FILE__, __LINE__, $db->error());

		// Remove him/her from the online list (if they happen to be logged in)
		$db->query('DELETE FROM '.$db->prefix.'online WHERE user_id='.$id) or error('Unable to remove user from online list', __FILE__, __LINE__, $db->error());

		// Should we delete all posts made by this user?
		if (isset($_POST['delete_posts']))
		{
			if ($db_type != 'mysql' && $db_type != 'mysqli')
				require PUN_ROOT.'include/search_idx.php';
			@set_time_limit(0);

			// Find all posts made by this user
			$result = $db->query('SELECT p.id, p.topic_id, t.forum_id FROM '.$db->prefix.'posts AS p INNER JOIN '.$db->prefix.'topics AS t ON t.id=p.topic_id INNER JOIN '.$db->prefix.'forums AS f ON f.id=t.forum_id WHERE p.poster_id='.$id) or error('Unable to fetch posts', __FILE__, __LINE__, $db->error());
			if ($db->num_rows($result))
			{
				while ($cur_post = $db->fetch_assoc($result))
				{
					// Determine whether this post is the "topic post" or not
					$result2 = $db->query('SELECT id FROM '.$db->prefix.'posts WHERE topic_id='.$cur_post['topic_id'].' ORDER BY posted LIMIT 1') or error('Unable to fetch post info', __FILE__, __LINE__, $db->error());

					if ($db->result($result2) == $cur_post['id'])
						delete_topic($cur_post['topic_id']);
					else
						delete_post($cur_post['id'], $cur_post['topic_id']);

					update_forum($cur_post['forum_id']);
				}
			}
		}
		else
			// Set all his/her posts to guest
			$db->query('UPDATE '.$db->prefix.'posts SET poster_id=1 WHERE poster_id='.$id) or error('Unable to update posts', __FILE__, __LINE__, $db->error());

		// Delete the user
		$db->query('DELETE FROM '.$db->prefix.'users WHERE id='.$id) or error('Unable to delete user', __FILE__, __LINE__, $db->error());

		// Delete user avatar
		@unlink($pun_config['o_avatars_dir'].'/'.$id.'.gif');
		@unlink($pun_config['o_avatars_dir'].'/'.$id.'.jpg');
		@unlink($pun_config['o_avatars_dir'].'/'.$id.'.png');

		($hook = get_hook('pf_delete_user')) ? eval($hook) : null;

		redirect(pun_link($pun_url['index']), $lang_profile['User delete redirect']);
	}


	// Setup breadcrumbs
	$pun_page['crumbs'] = array(
		array($pun_config['o_board_title'], pun_link($pun_url['index'])),
		array(sprintf($lang_profile['Users profile'], htmlspecialchars($user['username']), $lang_profile['Section admin']), pun_link($pun_url['profile_admin'], $id)),
		$lang_profile['Delete user']
	);

	define('PUN_PAGE', 'dialogue');
	require PUN_ROOT.'header.php';

	$fld_count = 0;

?>
<div id="pun-main1" class="a-section a-main">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

	<div class="b-section b-dataform">
		<div class="c-section c-form">
			<form method="post" accept-charset="utf-8" action="<?php echo pun_link($pun_url['user'], $id) ?>">
			<div class="panel">
				<input type="hidden" name="csrf_token" value="<?php echo $pun_user['csrf_token'] ?>" />
				<div class="textset">
					<p class="field">
						<strong class="alabel"><?php echo $lang_profile['Delete user'] ?></strong><br />
						<span class="input"><?php echo htmlspecialchars($user['username']) ?></span>
					</p>
					<p class="field">
						<strong class="alabel"><?php echo $lang_profile['Delete posts legend'] ?></strong><br />
						<span class="input"><input type="checkbox" id="fld<?php echo ++$fld_count ?>" name="delete_posts" value="1" checked="checked" /> <label for="fld<?php echo $fld_count ?>"><?php echo $lang_profile['Delete posts label'] ?></label></span>
					</p>
				</div>
				<div class="form-warn">
					<p><strong><?php echo $lang_common['Warning'] ?></strong> <?php echo $lang_profile['Delete warning'] ?></p>
				</div>
				<p class="formsubmit"><input type="submit" class="button" name="delete_user_comply" value="<?php echo $lang_profile['Delete'] ?>" /> <input type="submit" class="button" name="delete_user_cancel" value="<?php echo $lang_common['Cancel'] ?>" /></p>
			</div>
			</form>
		</div>
	</div>

</div>
<?php

	require PUN_ROOT.'footer.php';
}


else if (isset($_POST['form_sent']))
{
	// Make sure we are allowed to edit this user's profile
	if ($pun_user['id'] != $id &&
		$pun_user['g_id'] != PUN_ADMIN &&
		($pun_user['g_moderator'] != '1' || $pun_config['p_mod_edit_users'] == '0' || $user['g_id'] == PUN_ADMIN || $user['g_moderator'] == '1'))
		message($lang_common['No permission']);

	// Extract allowed elements from $_POST['form']
	function extract_elements($allowed_elements)
	{
		$form = array();

		while (list($key, $value) = @each($_POST['form']))
		{
			if (in_array($key, $allowed_elements))
				$form[$key] = $value;
		}

		return $form;
	}

	$username_updated = false;

	// Validate input depending on section
	switch ($section)
	{
		case 'identity':
		{
			$form = extract_elements(array('realname', 'url', 'location', 'jabber', 'icq', 'msn', 'aim', 'yahoo'));

			if ($pun_user['is_admmod'])
			{
				// Are we allowed to change usernames?
				if ($pun_user['g_id'] == PUN_ADMIN || ($pun_user['g_moderator'] == '1' && $pun_config['p_mod_rename_users'] == '1'))
				{
					$form['username'] = trim($_POST['req_username']);
					$old_username = trim($_POST['old_username']);

					if (pun_strlen($form['username']) < 2)
						message($lang_prof_reg['Username too short']);
					else if (pun_strlen($form['username']) > 25)	// This usually doesn't happen since the form element only accepts 25 characters
						message($lang_common['Bad request']);
					else if (strtolower($form['username']) == 'guest' || strtolower($form['username']) == strtolower($lang_common['Guest']))
						message($lang_prof_reg['Username guest']);
					else if (preg_match('/[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}/', $form['username']))
						message($lang_prof_reg['Username IP']);
					else if (preg_match('#\[b\]|\[/b\]|\[u\]|\[/u\]|\[i\]|\[/i\]|\[color|\[/color\]|\[quote\]|\[quote=|\[/quote\]|\[code\]|\[/code\]|\[img\]|\[/img\]|\[url|\[/url\]|\[email|\[/email\]#i', $form['username']))
						message($lang_prof_reg['Username BBCode']);

					// Check that the username (or a too similar username) is not already registered
					$result = $db->query('SELECT username FROM '.$db->prefix.'users WHERE id!='.$id.' AND (UPPER(username)=UPPER(\''.$db->escape($form['username']).'\') OR UPPER(username)=UPPER(\''.$db->escape(preg_replace('/[^\w]/', '', $form['username'])).'\'))') or error('Unable to fetch user info', __FILE__, __LINE__, $db->error());
					if ($db->num_rows($result))
					{
						$busy = $db->result($result);
						message(sprintf($lang_prof_reg['Username dupe'], htmlspecialchars($busy)));
					}

					if ($form['username'] != $old_username)
						$username_updated = true;
				}

				// We only allow administrators to update the post count
				if ($pun_user['g_id'] == PUN_ADMIN)
					$form['num_posts'] = intval($_POST['num_posts']);
			}

			if ($pun_config['o_regs_verify'] == '0' || $pun_user['is_admmod'])
			{
				require PUN_ROOT.'include/email.php';

				// Validate the email-address
				$form['email'] = strtolower(trim($_POST['req_email']));
				if (!is_valid_email($form['email']))
					message($lang_common['Invalid e-mail']);
			}

			if ($pun_user['is_admmod'])
				$form['admin_note'] = trim($_POST['admin_note']);

			if ($pun_user['g_id'] == PUN_ADMIN)
				$form['title'] = trim($_POST['title']);
			else if ($pun_user['g_set_title'] == '1')
			{
				$form['title'] = trim($_POST['title']);

				if ($form['title'] != '')
				{
					// A list of words that the title may not contain
					// If the language is English, there will be some duplicates, but it's not the end of the world
					$forbidden = array('Member', 'Moderator', 'Administrator', 'Banned', 'Guest', $lang_common['Member'], $lang_common['Moderator'], $lang_common['Administrator'], $lang_common['Banned'], $lang_common['Guest']);

					if (in_array($form['title'], $forbidden))
						message($lang_profile['Forbidden title']);
				}
			}

			// Add http:// if the URL doesn't contain it already
			if ($form['url'] != '' && !stristr($form['url'], 'http://'))
				$form['url'] = 'http://'.$form['url'];

			// If the ICQ UIN contains anything other than digits it's invalid
			if ($form['icq'] != '' && preg_match('/[^0-9]/', $form['icq']))
				message($lang_prof_reg['Bad ICQ']);

			break;
		}

		case 'preferences':
		{
			$form = extract_elements(array('dst', 'timezone', 'language', 'email_setting', 'save_pass', 'notify_with_post', 'auto_notify', 'time_format', 'date_format'));

			$form['dst'] = (isset($form['dst'])) ? 1 : 0;
			$form['time_format'] = (isset($form['time_format'])) ? intval($form['time_format']) : 0;
			$form['date_format'] = (isset($form['date_format'])) ? intval($form['date_format']) : 0;

			$form['email_setting'] = intval($form['email_setting']);
			if ($form['email_setting'] < 0 && $form['email_setting'] > 2) $form['email_setting'] = 1;

			if (!isset($form['save_pass']) || $form['save_pass'] != '1') $form['save_pass'] = '0';
			if (!isset($form['notify_with_post']) || $form['notify_with_post'] != '1') $form['notify_with_post'] = '0';
			if (!isset($form['auto_notify']) || $form['auto_notify'] != '1') $form['auto_notify'] = '0';

			// If the save_pass setting has changed, we need to set a new cookie with the appropriate expire date
			if ($pun_user['id'] == $id && $form['save_pass'] != $pun_user['save_pass'])
			{
				$result = $db->query('SELECT password FROM '.$db->prefix.'users WHERE id='.$id) or error('Unable to fetch user password hash', __FILE__, __LINE__, $db->error());
				pun_setcookie($id, $db->result($result), ($form['save_pass'] == '1') ? time() + 31536000 : 0);
			}

			// Make sure we got a valid language string
			if (isset($form['language']))
			{
				$form['language'] = preg_replace('#[\.\\\/]#', '', $form['language']);
				if (!file_exists(PUN_ROOT.'lang/'.$form['language'].'/common.php'))
					message($lang_common['Bad request']);
			}

			break;
		}

		case 'display':
		{
			$form = extract_elements(array('disp_topics', 'disp_posts', 'show_smilies', 'show_img', 'show_img_sig', 'show_avatars', 'show_sig', 'style'));

			if ($form['disp_topics'] != '' && intval($form['disp_topics']) < 3) $form['disp_topics'] = 3;
			if ($form['disp_topics'] != '' && intval($form['disp_topics']) > 75) $form['disp_topics'] = 75;
			if ($form['disp_posts'] != '' && intval($form['disp_posts']) < 3) $form['disp_posts'] = 3;
			if ($form['disp_posts'] != '' && intval($form['disp_posts']) > 75) $form['disp_posts'] = 75;

			if (!isset($form['show_smilies']) || $form['show_smilies'] != '1') $form['show_smilies'] = '0';
			if (!isset($form['show_img']) || $form['show_img'] != '1') $form['show_img'] = '0';
			if (!isset($form['show_img_sig']) || $form['show_img_sig'] != '1') $form['show_img_sig'] = '0';
			if (!isset($form['show_avatars']) || $form['show_avatars'] != '1') $form['show_avatars'] = '0';
			if (!isset($form['show_sig']) || $form['show_sig'] != '1') $form['show_sig'] = '0';

			// Make sure we got a valid style string
			if (isset($form['style']))
			{
				$form['style'] = preg_replace('#[\.\\\/]#', '', $form['style']);
				if (!file_exists(PUN_ROOT.'style/'.$form['style'].'/'.$form['style'].'.css'))
					message($lang_common['Bad request']);
			}
			break;
		}

		case 'signature':
		{
			if ($pun_config['o_signatures'] == '0')
				message($lang_profile['Signatures disabled']);

			// Clean up signature from POST
			$form['signature'] = pun_linebreaks(trim($_POST['signature']));

			// Validate signature
			if (pun_strlen($form['signature']) > $pun_config['p_sig_length'])
				message(sprintf($lang_prof_reg['Sig too long'], $pun_config['p_sig_length']));
			else if (substr_count($form['signature'], "\n") > ($pun_config['p_sig_lines'] - 1))
				message(sprintf($lang_prof_reg['Sig too many lines'], $pun_config['p_sig_lines']));
			else if ($form['signature'] && $pun_config['p_sig_all_caps'] == '0' && strtoupper($form['signature']) == $form['signature'] && !$pun_user['is_admmod'])
				$form['signature'] = ucwords(strtolower($form['signature']));

			// Validate BBCode syntax
			if ($pun_config['p_sig_bbcode'] == '1' && strpos($form['signature'], '[') !== false && strpos($form['signature'], ']') !== false)
			{
				require PUN_ROOT.'include/parser.php';
				$form['signature'] = preparse_bbcode($form['signature'], $foo, true);
			}

			break;
		}

		case 'avatar':
		{
			if ($pun_config['o_avatars'] == '0')
				message($lang_profile['Avatars disabled']);

			if (!isset($_FILES['req_file']))
				message($lang_profile['No file']);

			$uploaded_file = $_FILES['req_file'];

			// Make sure the upload went smooth
			if (isset($uploaded_file['error']))
			{
				switch ($uploaded_file['error'])
				{
					case 1:	// UPLOAD_ERR_INI_SIZE
					case 2:	// UPLOAD_ERR_FORM_SIZE
						message($lang_profile['Too large ini']);
						break;

					case 3:	// UPLOAD_ERR_PARTIAL
						message($lang_profile['Partial upload']);
						break;

					case 4:	// UPLOAD_ERR_NO_FILE
						message($lang_profile['No file']);
						break;

					case 6:	// UPLOAD_ERR_NO_TMP_DIR
						message($lang_profile['No tmp directory']);
						break;

					default:
						// No error occured, but was something actually uploaded?
						if ($uploaded_file['size'] == 0)
							message($lang_profile['No file']);
						break;
				}
			}

			if (is_uploaded_file($uploaded_file['tmp_name']))
			{
				$allowed_types = array('image/gif', 'image/jpeg', 'image/pjpeg', 'image/png', 'image/x-png');
				if (!in_array($uploaded_file['type'], $allowed_types))
					message($lang_profile['Bad type']);

				// Make sure the file isn't too big
				if ($uploaded_file['size'] > $pun_config['o_avatars_size'])
					message(sprintf($lang_profile['Too large'], $pun_config['o_avatars_size']));

				// Determine type
				$extensions = null;
				if ($uploaded_file['type'] == 'image/gif')
					$extensions = array('.gif', '.jpg', '.png');
				else if ($uploaded_file['type'] == 'image/jpeg' || $uploaded_file['type'] == 'image/pjpeg')
					$extensions = array('.jpg', '.gif', '.png');
				else
					$extensions = array('.png', '.gif', '.jpg');

				// Move the file to the avatar directory. We do this before checking the width/height to circumvent open_basedir restrictions.
				if (!@move_uploaded_file($uploaded_file['tmp_name'], $pun_config['o_avatars_dir'].'/'.$id.'.tmp'))
					message(sprintf($lang_profile['Move failed'], '<a href="mailto:'.$pun_config['o_admin_email'].'">'.$pun_config['o_admin_email'].'</a>'));

				// Now check the width/height
				list($width, $height, $type,) = getimagesize($pun_config['o_avatars_dir'].'/'.$id.'.tmp');
				if (empty($width) || empty($height) || $width > $pun_config['o_avatars_width'] || $height > $pun_config['o_avatars_height'])
				{
					@unlink($pun_config['o_avatars_dir'].'/'.$id.'.tmp');
					message(sprintf($lang_profile['Too wide or high'], $pun_config['o_avatars_width'], $pun_config['o_avatars_height']));
				}
				else if ($type == 1 && $uploaded_file['type'] != 'image/gif')	// Prevent dodgy uploads
				{
					@unlink($pun_config['o_avatars_dir'].'/'.$id.'.tmp');
					message($lang_profile['Bad type']);
				}

				// Delete any old avatars and put the new one in place
				@unlink($pun_config['o_avatars_dir'].'/'.$id.$extensions[0]);
				@unlink($pun_config['o_avatars_dir'].'/'.$id.$extensions[1]);
				@unlink($pun_config['o_avatars_dir'].'/'.$id.$extensions[2]);
				@rename($pun_config['o_avatars_dir'].'/'.$id.'.tmp', $pun_config['o_avatars_dir'].'/'.$id.$extensions[0]);
				@chmod($pun_config['o_avatars_dir'].'/'.$id.$extensions[0], 0644);
			}
			else
				message($lang_profile['Unknown failure']);

			break;
		}

		default:
			message($lang_common['Bad request']);
	}

	// All sections apart from avatar potentially affect the database
	if ($section != 'avatar')
	{
		// Singlequotes around non-empty values and NULL for empty values
		$temp = array();
		while (list($key, $input) = @each($form))
		{
			$value = ($input !== '') ? '\''.$db->escape($input).'\'' : 'NULL';

			$temp[] = $key.'='.$value;
		}

		// Make sure we have something to update
		if (empty($temp))
			message($lang_common['Bad request']);

		// Run the update
		$query = array(
			'UPDATE'	=> 'users',
			'SET'		=> implode(',', $temp),
			'WHERE'		=> 'id='.$id
		);

		$db->query_build($query) or error('Unable to update profile', __FILE__, __LINE__, $db->error());

		// If we changed the username we have to update some stuff
		if ($username_updated)
		{
			$db->query('UPDATE '.$db->prefix.'posts SET poster=\''.$db->escape($form['username']).'\' WHERE poster_id='.$id) or error('Unable to update posts', __FILE__, __LINE__, $db->error());
			$db->query('UPDATE '.$db->prefix.'topics SET poster=\''.$db->escape($form['username']).'\' WHERE poster=\''.$db->escape($old_username).'\'') or error('Unable to update topics', __FILE__, __LINE__, $db->error());
			$db->query('UPDATE '.$db->prefix.'topics SET last_poster=\''.$db->escape($form['username']).'\' WHERE last_poster=\''.$db->escape($old_username).'\'') or error('Unable to update topics', __FILE__, __LINE__, $db->error());
			$db->query('UPDATE '.$db->prefix.'forums SET last_poster=\''.$db->escape($form['username']).'\' WHERE last_poster=\''.$db->escape($old_username).'\'') or error('Unable to update forums', __FILE__, __LINE__, $db->error());
			$db->query('UPDATE '.$db->prefix.'online SET ident=\''.$db->escape($form['username']).'\' WHERE ident=\''.$db->escape($old_username).'\'') or error('Unable to update online list', __FILE__, __LINE__, $db->error());

			// If the user is a moderator or an administrator we have to update the moderator lists
			if ($user['g_id'] == PUN_ADMIN || $user['g_moderator'] == '1')
			{
				$result = $db->query('SELECT id, moderators FROM '.$db->prefix.'forums') or error('Unable to fetch forum list', __FILE__, __LINE__, $db->error());

				while ($cur_forum = $db->fetch_assoc($result))
				{
					$cur_moderators = ($cur_forum['moderators'] != '') ? unserialize($cur_forum['moderators']) : array();

					if (in_array($id, $cur_moderators))
					{
						unset($cur_moderators[$old_username]);
						$cur_moderators[$form['username']] = $id;
						ksort($cur_moderators);

						$db->query('UPDATE '.$db->prefix.'forums SET moderators=\''.$db->escape(serialize($cur_moderators)).'\' WHERE id='.$cur_forum['id']) or error('Unable to update forum', __FILE__, __LINE__, $db->error());
					}
				}
			}
		}
	}

	redirect(pun_link($pun_url['profile_'.$section], $id), $lang_profile['Profile redirect']);
}


if ($user['signature'] != '')
{
	require PUN_ROOT.'include/parser.php';
	$parsed_signature = parse_signature($user['signature']);
}


// View or edit?
if ($pun_user['id'] != $id &&
	$pun_user['g_id'] != PUN_ADMIN &&
	($pun_user['g_moderator'] != '1' || $pun_config['p_mod_edit_users'] == '0' || $user['g_id'] == PUN_ADMIN || $user['g_moderator'] == '1'))
{
	if ($user['email_setting'] == '0' && !$pun_user['is_guest'])
		$email_field = '<a href="mailto:'.$user['email'].'" class="email">'.$user['email'].'</a>';
	else if ($user['email_setting'] == '1' && !$pun_user['is_guest'])
		$email_field = '<a href="'.pun_link($pun_url['email'], $id).'">'.$lang_common['Send e-mail'].'</a>';
	else
		$email_field = $lang_profile['Private'];

	if ($user['url'] != '')
	{
		$user['url'] = htmlspecialchars($user['url']);

		if ($pun_config['o_censoring'] == '1')
			$user['url'] = censor_words($user['url']);

		$url = '<a href="'.$user['url'].'" class="url" rel="me">'.$user['url'].'</a>';
	}
	else
		$url = $lang_profile['Unknown'];

	if ($pun_config['o_avatars'] == '1')
	{
		if ($img_size = @getimagesize($pun_config['o_avatars_dir'].'/'.$id.'.gif'))
			$avatar_field = '<div class="input"><img class="photo" src="'.$base_url.'/'.$pun_config['o_avatars_dir'].'/'.$id.'.gif" '.$img_size[3].' alt="" /></div>';
		else if ($img_size = @getimagesize($pun_config['o_avatars_dir'].'/'.$id.'.jpg'))
			$avatar_field = '<div class="input"><img class="photo" src="'.$base_url.'/'.$pun_config['o_avatars_dir'].'/'.$id.'.jpg" '.$img_size[3].' alt="" /></div>';
		else if ($img_size = @getimagesize($pun_config['o_avatars_dir'].'/'.$id.'.png'))
			$avatar_field = '<div class="input"><img class="photo" src="'.$base_url.'/'.$pun_config['o_avatars_dir'].'/'.$id.'.png" '.$img_size[3].' alt="" /></div>';
		else
			$avatar_field = '<span class="input">'.$lang_profile['No avatar'].'</span>';
	}

	$posts_field = '';
	if ($pun_config['o_show_post_count'] == '1' || $pun_user['is_admmod'])
		$posts_field = $user['num_posts'];
	if ($pun_user['g_search'] == '1')
		$posts_field .= (($posts_field != '') ? ' - ' : '').'<a href="'.pun_link($pun_url['search_user'], $id).'">'.$lang_profile['Show posts'].'</a>';


	// Setup breadcrumbs
	$pun_page['crumbs'] = array(
		array($pun_config['o_board_title'], pun_link($pun_url['index'])),
		sprintf($lang_profile['View profile'], htmlspecialchars($user['username']))
	);

	define('PUN_ALLOW_INDEX', 1);
	define('PUN_PAGE', 'profile');
	require PUN_ROOT.'header.php';

?>
<div id="pun-main1" class="a-section a-main">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

	<div id="viewprofile" class="b-section b-dataform">
		<div class="c-section c-form vcard">
			<div class="panel">
				<h2><span class="input"><?php echo $lang_profile['Personal legend'] ?></span></h2>
				<ul class="textset">
					<li class="field"><strong class="alabel"><?php echo $lang_common['Username'] ?></strong><br /> <span class="input<?php if ($user['realname'] =='') echo ' fn' ?> nickname"><?php echo htmlspecialchars($user['username']) ?></span></li>
					<li class="field"><strong class="alabel"><?php echo $lang_common['Title'] ?></strong><br /> <span class="input"><?php echo get_title($user) ?></span></li>
					<li class="field"><strong class="alabel"><?php echo $lang_profile['Realname'] ?></strong><br /> <span class="input<?php if ($user['realname'] !='') echo ' fn' ?>"><?php echo ($user['realname'] !='') ? htmlspecialchars(($pun_config['o_censoring'] == '1') ? censor_words($user['realname']) : $user['realname']) : $lang_profile['Unknown']; ?></span></li>
					<li class="field"><strong class="alabel"><?php echo $lang_profile['Location'] ?></strong><br /> <span class="input"><?php echo ($user['location'] !='') ? htmlspecialchars(($pun_config['o_censoring'] == '1') ? censor_words($user['location']) : $user['location']) : $lang_profile['Unknown']; ?></span></li>
<?php if ($posts_field != ''): ?>					<li class="field"><strong class="alabel"><?php echo $lang_common['Posts'] ?></strong><br /> <span class="input"><?php echo $posts_field ?></span></li>
<?php endif; ?>					<li class="field"><strong class="alabel"><?php echo $lang_common['Last post'] ?></strong><br /> <span class="input"><?php echo format_time($user['last_post']) ?></span></li>
					<li class="field"><strong class="alabel"><?php echo $lang_common['Registered'] ?></strong><br /> <span class="input"><?php echo format_time($user['registered'], true) ?></span></li>
<?php ($hook = get_hook('pf_view_section_personal')) ? eval($hook) : null; ?>
				</ul>
			</div>
			<div class="panel">
				<h2><span class="input"><?php echo $lang_profile['Contact legend'] ?></span></h2>
				<ul class="textset">
					<li class="field"><strong class="alabel"><?php echo $lang_prof_reg['E-mail address'] ?></strong><br /> <span class="input"><?php echo $email_field ?></span></li>
					<li class="field"><strong class="alabel"><?php echo $lang_profile['Website'] ?></strong><br /> <span class="input"><?php echo $url ?></span></li>
					<li class="field"><strong class="alabel"><?php echo $lang_profile['Jabber'] ?></strong><br /> <span class="input"><?php echo ($user['jabber'] !='') ? htmlspecialchars($user['jabber']) : $lang_profile['Unknown']; ?></span></li>
					<li class="field"><strong class="alabel"><?php echo $lang_profile['ICQ'] ?></strong><br /> <span class="input"><?php echo ($user['icq'] !='') ? $user['icq'] : $lang_profile['Unknown']; ?></span></li>
					<li class="field"><strong class="alabel"><?php echo $lang_profile['MSN'] ?></strong><br /> <span class="input"><?php echo ($user['msn'] !='') ? htmlspecialchars(($pun_config['o_censoring'] == '1') ? censor_words($user['msn']) : $user['msn']) : $lang_profile['Unknown']; ?></span></li>
					<li class="field"><strong class="alabel"><?php echo $lang_profile['AOL IM'] ?></strong><br /> <span class="input"><?php echo ($user['aim'] !='') ? htmlspecialchars(($pun_config['o_censoring'] == '1') ? censor_words($user['aim']) : $user['aim']) : $lang_profile['Unknown']; ?></span></li>
					<li class="field"><strong class="alabel"><?php echo $lang_profile['Yahoo'] ?></strong><br /> <span class="input"><?php echo ($user['yahoo'] !='') ? htmlspecialchars(($pun_config['o_censoring'] == '1') ? censor_words($user['yahoo']) : $user['yahoo']) : $lang_profile['Unknown']; ?></span></li>
<?php ($hook = get_hook('pf_view_section_contact')) ? eval($hook) : null; ?>
				</ul>
			</div>
<?php if ($pun_config['o_avatars'] == '1' || $pun_config['o_signatures'] == '1'): ?>			<div class="panel">
				<h2><span class="input"><?php echo ($pun_config['o_avatars'] == '1' && $pun_config['o_signatures'] == '1') ? $lang_profile['Section avatar'].' - '.$lang_profile['Section signature'] : (($pun_config['o_avatars'] == '1') ? $lang_profile['Section avatar'] : $lang_profile['Section signature']) ?></span></h2>
				<ul class="textset">
<?php if ($pun_config['o_avatars'] == '1'): ?>					<li class="field"><strong class="alabel"><?php echo $lang_profile['Avatar'] ?></strong><br /> <?php echo $avatar_field ?></li>
<?php endif; if ($pun_config['o_signatures'] == '1'): ?>					<li class="field"><strong class="alabel"><?php echo $lang_profile['Signature'] ?></strong><br /> <?php echo isset($parsed_signature) ? '<div class="input">'.$parsed_signature.'</div>' : '<span class="input">'.$lang_profile['No sig'].'</span>'; ?></li>
<?php endif; ?>				</ul>
			</div>
<?php endif; ?>		</div>
	</div>

</div>
<?php

	require PUN_ROOT.'footer.php';
}


else
{
	// Setup breadcrumbs
	$pun_page['crumbs'] = array(
		array($pun_config['o_board_title'], pun_link($pun_url['index'])),
		sprintf($lang_profile['Users profile'], htmlspecialchars($user['username']), (!$section || $section == 'identity') ? $lang_profile['Section identity'] : $lang_profile['Section '.$section.''])
	);

	if (!$section || $section == 'identity')
	{
		$ident_options = array();

		if ($pun_user['id'] == $id || $pun_user['g_id'] == PUN_ADMIN || ($pun_user['g_moderator'] == '1' && $pun_config['p_mod_change_passwords'] == '1'))
			$ident_options[] = '<li><a href="'.pun_link($pun_url['change_password'], $id).'">'.$lang_profile['Change pass'].'</a></li>';

		if ($pun_user['is_admmod'])
			$ident_options[] =  '<li><a href="'.pun_link($pun_url['email'], $id).'">'.sprintf($lang_common['Send e-mail to'], htmlspecialchars($user['username'])).'</a></li>';
		else
		{
			if ($pun_config['o_regs_verify'] == '1')
				$ident_options[] = '<li><a href="'.pun_link($pun_url['change_email'], $id).'">'.$lang_profile['Change e-mail'].'</a></li>';
		}

		$ident_options[] = '<li><a href="'.pun_link($pun_url['search_user'], $id).'">'.$lang_profile['Show posts'].'</a></li>';

		define('PUN_PAGE', 'profile-identity');
		require PUN_ROOT.'header.php';

		$fld_count = 0;

?>
<div id="pun-main1" class="a-section a-main">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

<?php generate_profile_menu(); ?>

	<div id="editprofile" class="b-section b-dataform">
		<div class="c-section c-form">
			<form method="post" accept-charset="utf-8" action="<?php echo pun_link($pun_url['profile_identity'], $id) ?>">
			<div class="panel vcard">
<?php if ($pun_user['is_admmod']): ?>				<input type="hidden" name="csrf_token" value="<?php echo $pun_user['csrf_token'] ?>" />
<?php endif; ?>				<div class="form-intro">
					<p><?php echo $lang_profile['Identity intro']; if (!empty($ident_options)) echo ' '.$lang_profile['Identity intro options'] ?></p>
<?php if (!empty($ident_options)): ?>					<ul class="optionlist">
						<?php echo implode("\n\t\t\t\t\t\t", $ident_options)."\n"; ?>
					</ul>
<?php endif ?>				</div>
				<p id="req-msg" class="req-warn"><?php printf($lang_common['Required warn'], '<em class="req-text">'.$lang_common['Required mark'].'<span> '.$lang_common['Required'].'</span></em>') ?></p>
				<fieldset class="textset">
					<legend><span><?php echo $lang_profile['Personal legend'] ?></span></legend>
					<input type="hidden" name="form_sent" value="1" />
<?php if ($pun_user['is_admmod'] && ($pun_user['g_id'] == PUN_ADMIN || $pun_config['p_mod_rename_users'] == '1')): ?>
					<input type="hidden" name="old_username" value="<?php echo htmlspecialchars($user['username']) ?>" />
					<p class="field required">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo $lang_common['Username'] ?><span class="acchide">(<strong class="nickname<?php echo ($user['realname'] =='') ? ' fn' : '' ?>"><?php echo htmlspecialchars($user['username']) ?></strong>)</span> <em class="req-text"><?php echo $lang_common['Required mark'] ?><span class="acchide"><?php echo $lang_common['Required'] ?></span></em></label><br />
						<span class="input"><input type="text" id="fld<?php echo $fld_count ?>" name="req_username" value="<?php echo htmlspecialchars($user['username']) ?>" size="25" maxlength="25" /></span>
					</p>
<?php endif; if (!$pun_user['is_admmod']): ?>					<p class="field">
						<strong class="alabel"><?php echo $lang_common['Username'] ?></strong><br />
						<span class="input nickname<?php echo ($user['realname'] =='') ? ' fn' : '' ?>"><?php echo htmlspecialchars($user['username']) ?></span>
					</p>
<?php endif; ?>					<p class="field">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo $lang_profile['Realname']; if ($user['realname'] !='') echo ' <span class="acchide">(<strong class="fn">'.htmlspecialchars(($pun_config['o_censoring'] == '1') ? censor_words($user['realname']) : $user['realname']).'</strong>)</span>' ?></label><br />
						<span class="input"><input type="text" id="fld<?php echo $fld_count ?>" name="form[realname]" value="<?php echo htmlspecialchars($user['realname']) ?>" size="40" maxlength="40" /></span>
					</p>
<?php if ($pun_user['g_set_title'] == '1'): ?>					<p class="field">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo $lang_common['Title'] ?></label><br />
						<span class="input"><input type="text" id="fld<?php echo $fld_count ?>" name="title" value="<?php echo htmlspecialchars($user['title']) ?>" size="30" maxlength="50" /> <em><?php echo $lang_profile['Leave blank'] ?></em></span>
					</p>
<?php endif; ?>					<p class="field">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo $lang_profile['Location'] ?></label><br />
						<span class="input"><input type="text" id="fld<?php echo $fld_count ?>" name="form[location]" value="<?php echo htmlspecialchars($user['location']) ?>" size="30" maxlength="30" /></span>
					</p>
					<p class="field">
						<strong class="alabel"><?php echo $lang_common['Registered'] ?></strong><br />
						<span class="input"><?php echo format_time($user['registered'], true); if ($pun_user['is_admmod']) echo ' (<a href="'.pun_link($pun_url['get_host'], htmlspecialchars($user['registration_ip'])).'">'.htmlspecialchars($user['registration_ip']).'</a>)'; ?></span>
					</p>
					<p class="field">
						<strong class="alabel"><?php echo $lang_common['Last post'] ?></strong><br />
						<span class="input"><?php echo format_time($user['last_post']) ?></span>
					</p>
<?php if ($pun_user['g_id'] == PUN_ADMIN): ?>					<p class="field">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo $lang_common['Posts'] ?></label><br />
						<span class="input"><input type="text" id="fld<?php echo $fld_count ?>" name="num_posts" value="<?php echo $user['num_posts'] ?>" size="8" maxlength="8" /></span>
					</p>
<?php endif; if ($pun_user['g_id'] != PUN_ADMIN && ($pun_config['o_show_post_count'] == '1' || $pun_user['is_admmod'])): ?>					<p class="field">
						<strong class="alabel"><?php echo $lang_common['Posts'] ?></strong><br />
						<span class="input">[ <?php echo $user['num_posts'] ?> ]</span>
					</p>
<?php endif; if ($pun_user['is_admmod']): ?>					<p class="field">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo $lang_profile['Admin note'] ?></label><br />
						<span class="input"><input id="fld<?php echo $fld_count ?>" type="text" name="admin_note" value="<?php echo htmlspecialchars($user['admin_note']) ?>" size="30" maxlength="30" /></span>
					</p>
<?php endif; ?>				</fieldset>
				<fieldset class="textset">
					<legend><span><?php echo $lang_profile['Contact legend'] ?></span></legend>
<?php if (!$pun_user['is_admmod'] && $pun_config['o_regs_verify'] == '1'): ?>					<p class="field">
						<strong class="alabel"><?php echo $lang_prof_reg['E-mail address'] ?></strong><br />
						<span class="input"><a href="mailto:<?php echo $user['email'] ?>" class="email"><?php echo $user['email'] ?></a></span>
					</p>
<?php endif; if ($pun_user['is_admmod'] || $pun_config['o_regs_verify'] != '1'): ?>					<p class="field">
					<p class="field required">
						<label for="fld<?php echo ++$fld_count ?>"><a href="mailto:<?php echo $user['email'] ?>" class="email"><?php echo $lang_prof_reg['E-mail address'] ?></a> <em class="req-text"><?php echo $lang_common['Required mark'].'<span class="acchide"> '.$lang_common['Required'].'</span>' ?></em></label><br />
						<span class="input"><input type="text" id="fld<?php echo $fld_count ?>" name="req_email" value="<?php echo $user['email'] ?>" size="40" maxlength="80" /></span>
					</p>
<?php endif; ?>					<p class="field">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo ($user['url'] != '') ? '<a class="url" rel="me" href="'.htmlspecialchars($user['url']).'">'.$lang_profile['Website'].' <span class="acchide url">'.htmlspecialchars($user['url']).'</span></a>' : $lang_profile['Website'] ?></label><br />
						<span class="input"><input type="text" id="fld<?php echo $fld_count ?>" name="form[url]" value="<?php echo htmlspecialchars($user['url']) ?>" size="50" maxlength="80" /></span>
					</p>
					<p class="field">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo $lang_profile['Jabber'] ?></label><br />
						<span class="input"><input id="fld<?php echo $fld_count ?>" type="text" name="form[jabber]" value="<?php echo htmlspecialchars($user['jabber']) ?>" size="40" maxlength="80" /></span>
					</p>
					<p class="field">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo $lang_profile['ICQ'] ?></label><br />
						<span class="input"><input id="fld<?php echo $fld_count ?>" type="text" name="form[icq]" value="<?php echo $user['icq'] ?>" size="12" maxlength="12" /></span>
					</p>
					<p class="field">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo $lang_profile['MSN'] ?></label><br />
						<span class="input"><input id="fld<?php echo $fld_count ?>" type="text" name="form[msn]" value="<?php echo htmlspecialchars($user['msn']) ?>" size="40" maxlength="80" /></span>
					</p>
					<p class="field">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo $lang_profile['AOL IM'] ?></label><br />
						<span class="input"><input id="fld<?php echo $fld_count ?>" type="text" name="form[aim]" value="<?php echo htmlspecialchars($user['aim']) ?>" size="20" maxlength="30" /></span>
					</p>
					<p class="field">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo $lang_profile['Yahoo'] ?></label><br />
						<span class="input"><input id="fld<?php echo $fld_count ?>" type="text" name="form[yahoo]" value="<?php echo htmlspecialchars($user['yahoo']) ?>" size="20" maxlength="30" /></span>
					</p>
<?php ($hook = get_hook('pf_edit_identity_contact')) ? eval($hook) : null; ?>
				</fieldset>
				<p class="formsubmit"><input type="submit" class="button" name="update" value="<?php echo $lang_common['Submit'] ?>" /> <?php echo $lang_profile['Instructions'] ?></p>
			</div>
			</form>
		</div>
	</div>

</div>
<?php

	}
	else if ($section == 'preferences')
	{
		define('PUN_PAGE', 'profile-preferences');
		require PUN_ROOT.'header.php';

		$fld_count = 0;

?>
<div id="pun-main1" class="a-section a-main">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

<?php generate_profile_menu(); ?>

	<div id="editprofile" class="b-section b-dataform">
		<div class="c-section c-form">
			<form method="post" accept-charset="utf-8" action="<?php echo pun_link($pun_url['profile_preferences'], $id) ?>">
			<div class="panel">
<?php if ($pun_user['is_admmod']): ?>				<input type="hidden" name="csrf_token" value="<?php echo $pun_user['csrf_token'] ?>" />
<?php endif; ?>				<div class="form-intro">
					<p><?php echo $lang_profile['Preferences intro'] ?></p>
				</div>
				<fieldset class="textset">
					<legend><span><?php echo $lang_prof_reg['Local legend'] ?></span></legend>
<?php

		$languages = array();
		$d = dir(PUN_ROOT.'lang');
		while (($entry = $d->read()) !== false)
		{
			if ($entry != '.' && $entry != '..' && is_dir(PUN_ROOT.'lang/'.$entry) && file_exists(PUN_ROOT.'lang/'.$entry.'/common.php'))
				$languages[] = $entry;
		}
		$d->close();

		// Only display the language selection box if there's more than one language available
		if (count($languages) > 1)
		{
			natcasesort($languages);

?>
					<p class="field">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo $lang_prof_reg['Language'] ?></label><br />
						<span class="input"><select id="fld<?php echo $fld_count ?>" name="form[language]">
<?php

			while (list(, $temp) = @each($languages))
			{
				if ($pun_user['language'] == $temp)
					echo "\t\t\t\t\t\t".'<option value="'.$temp.'" selected="selected">'.$temp.'</option>'."\n";
				else
					echo "\t\t\t\t\t\t".'<option value="'.$temp.'">'.$temp.'</option>'."\n";
			}

?>
						</select></span>
					</p>
<?php

		}

?>
					<p class="field">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo $lang_prof_reg['Timezone'] ?></label><br />
						<span class="input"><select id="fld<?php echo $fld_count ?>" name="form[timezone]">
							<option value="-12"<?php if ($user['timezone'] == -12) echo ' selected="selected"' ?>>-12</option>
							<option value="-11"<?php if ($user['timezone'] == -11) echo ' selected="selected"' ?>>-11</option>
							<option value="-10"<?php if ($user['timezone'] == -10) echo ' selected="selected"' ?>>-10</option>
							<option value="-9.5"<?php if ($user['timezone'] == -9.5) echo ' selected="selected"' ?>>-09.5</option>
							<option value="-9"<?php if ($user['timezone'] == -9) echo ' selected="selected"' ?>>-09</option>
							<option value="-8.5"<?php if ($user['timezone'] == -8.5) echo ' selected="selected"' ?>>-08.5</option>
							<option value="-8"<?php if ($user['timezone'] == -8) echo ' selected="selected"' ?>>-08 PST</option>
							<option value="-7"<?php if ($user['timezone'] == -7) echo ' selected="selected"' ?>>-07 MST</option>
							<option value="-6"<?php if ($user['timezone'] == -6) echo ' selected="selected"' ?>>-06 CST</option>
							<option value="-5"<?php if ($user['timezone'] == -5) echo ' selected="selected"' ?>>-05 EST</option>
							<option value="-4"<?php if ($user['timezone'] == -4) echo ' selected="selected"' ?>>-04 AST</option>
							<option value="-3.5"<?php if ($user['timezone'] == -3.5) echo ' selected="selected"' ?>>-03.5</option>
							<option value="-3"<?php if ($user['timezone'] == -3) echo ' selected="selected"' ?>>-03 ADT</option>
							<option value="-2"<?php if ($user['timezone'] == -2) echo ' selected="selected"' ?>>-02</option>
							<option value="-1"<?php if ($user['timezone'] == -1) echo ' selected="selected"' ?>>-01</option>
							<option value="0"<?php if ($user['timezone'] == 0) echo ' selected="selected"' ?>>00 GMT</option>
							<option value="1"<?php if ($user['timezone'] == 1) echo ' selected="selected"' ?>>+01 CET</option>
							<option value="2"<?php if ($user['timezone'] == 2) echo ' selected="selected"' ?>>+02</option>
							<option value="3"<?php if ($user['timezone'] == 3) echo ' selected="selected"' ?>>+03</option>
							<option value="3.5"<?php if ($user['timezone'] == 3.5) echo ' selected="selected"' ?>>+03.5</option>
							<option value="4"<?php if ($user['timezone'] == 4) echo ' selected="selected"' ?>>+04</option>
							<option value="4.5"<?php if ($user['timezone'] == 4.5) echo ' selected="selected"' ?>>+04.5</option>
							<option value="5"<?php if ($user['timezone'] == 5) echo ' selected="selected"' ?>>+05</option>
							<option value="5.5"<?php if ($user['timezone'] == 5.5) echo ' selected="selected"' ?>>+05.5</option>
							<option value="6"<?php if ($user['timezone'] == 6) echo ' selected="selected"' ?>>+06</option>
							<option value="6.5"<?php if ($user['timezone'] == 6.5) echo ' selected="selected"' ?>>+06.5</option>
							<option value="7"<?php if ($user['timezone'] == 7) echo ' selected="selected"' ?>>+07</option>
							<option value="8"<?php if ($user['timezone'] == 8) echo ' selected="selected"' ?>>+08</option>
							<option value="9"<?php if ($user['timezone'] == 9) echo ' selected="selected"' ?>>+09</option>
							<option value="9.5"<?php if ($user['timezone'] == 9.5) echo ' selected="selected"' ?>>+09.5</option>
							<option value="10"<?php if ($user['timezone'] == 10) echo ' selected="selected"' ?>>+10</option>
							<option value="10.5"<?php if ($user['timezone'] == 10.5) echo ' selected="selected"' ?>>+10.5</option>
							<option value="11"<?php if ($user['timezone'] == 11) echo ' selected="selected"' ?>>+11</option>
							<option value="11.5"<?php if ($user['timezone'] == 11.5) echo ' selected="selected"' ?>>+11.5</option>
							<option value="12"<?php if ($user['timezone'] == 12) echo ' selected="selected"' ?>>+12</option>
							<option value="13"<?php if ($user['timezone'] == 13) echo ' selected="selected"' ?>>+13</option>
							<option value="14"<?php if ($user['timezone'] == 14) echo ' selected="selected"' ?>>+14</option>
						</select></span>
						<span class="input"><input type="checkbox" id="fld<?php echo ++$fld_count ?>" name="form[dst]" value="1" <?php if ($user['dst'] == 1) echo ' checked="checked"' ?> /> <label for="fld<?php echo $fld_count ?>"><?php echo $lang_prof_reg['DST label'] ?></label></span>
					</p>
					<p class="field">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo $lang_profile['Time format'] ?></label><br />
						<span class="input"><select id="fld<?php echo $fld_count ?>" name="form[time_format]">
<?php

		foreach (array_unique($pun_time_formats) as $key => $time_format)
		{
			echo "\t\t\t\t\t\t".'<option value="'.$key.'"';
			if ($user['time_format'] == $key)
				echo ' selected="selected"';
			echo '>'. gmdate($time_format);
			if ($key == 0)
				echo ' ('.$lang_profile['Default'].')';
			echo "</option>\n";
		}

?>
						</select></span>
					</p>
					<p class="field">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo $lang_profile['Date format'] ?></label><br />
						<span class="input"><select id="fld<?php echo $fld_count ?>" name="form[date_format]">
<?php

		foreach (array_unique($pun_date_formats) as $key => $date_format)
		{
			echo "\t\t\t\t\t\t\t".'<option value="'.$key.'"';
			if ($user['date_format'] == $key)
				echo ' selected="selected"';
			echo '>'. gmdate($date_format);
			if ($key == 0)
				echo ' ('.$lang_profile['Default'].')';
			echo "</option>\n";
		}

?>
						</select></span>
					</p>
				</fieldset>
				<input type="hidden" name="form_sent" value="1" />
				<fieldset class="radioset">
					<legend><span><?php echo $lang_prof_reg['E-mail visibility legend'] ?></span></legend>
					<p class="field">
						<span class="input"><input type="radio" id="fld<?php echo ++$fld_count ?>" name="form[email_setting]" value="0"<?php if ($user['email_setting'] == '0') echo ' checked="checked"' ?> /> <label for="fld<?php echo $fld_count ?>"><?php echo $lang_prof_reg['E-mail setting 1'] ?></label></span><br />
						<span class="input"><input type="radio" id="fld<?php echo ++$fld_count ?>" name="form[email_setting]" value="1"<?php if ($user['email_setting'] == '1') echo ' checked="checked"' ?> /> <label for="fld<?php echo $fld_count ?>"><?php echo $lang_prof_reg['E-mail setting 2'] ?></label></span><br />
						<span class="input"><input type="radio" id="fld<?php echo ++$fld_count ?>" name="form[email_setting]" value="2"<?php if ($user['email_setting'] == '2') echo ' checked="checked"' ?> /> <label for="fld<?php echo $fld_count ?>"><?php echo $lang_prof_reg['E-mail setting 3'] ?></label></span><br />
					</p>
				</fieldset>
				<fieldset class="checkset">
					<legend><span><?php echo $lang_profile['Subscription legend'] ?></span></legend>
					<p class="field">
						<span class="input"><input type="checkbox" id="fld<?php echo ++$fld_count ?>" name="form[notify_with_post]" value="1"<?php if ($user['notify_with_post'] == '1') echo ' checked="checked"' ?> /> <label for="fld<?php echo $fld_count ?>"><?php echo $lang_profile['Notify full'] ?></label></span><br />
						<span class="input"><input type="checkbox" id="fld<?php echo ++$fld_count ?>" name="form[auto_notify]" value="1"<?php if ($user['auto_notify'] == '1') echo ' checked="checked"' ?> /> <label for="fld<?php echo $fld_count ?>"><?php echo $lang_profile['Subscribe by default'] ?></label></span><br />
					</p>
				</fieldset>
				<fieldset class="checkset">
					<legend><span><?php echo $lang_prof_reg['Persistent login legend'] ?></span></legend>
					<p class="field">
						<span class="input"><input type="checkbox" id="fld<?php echo ++$fld_count ?>" name="form[save_pass]" value="1"<?php if ($user['save_pass'] == '1') echo ' checked="checked"' ?> /> <label for="fld<?php echo $fld_count ?>"><?php echo $lang_prof_reg['Save user/pass'] ?></label></span><br />
					</p>
				</fieldset>
				<p class="formsubmit"><input type="submit" class="button" name="update" value="<?php echo $lang_common['Submit'] ?>" /> <?php echo $lang_profile['Instructions'] ?></p>
			</div>
			</form>
		</div>
	</div>

</div>
<?php

	}
	else if ($section == 'display')
	{
		define('PUN_PAGE', 'profile-display');
		require PUN_ROOT.'header.php';

		$fld_count = 0;

?>
<div id="pun-main1" class="a-section a-main">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

<?php generate_profile_menu(); ?>

	<div id="editprofile" class="b-section b-dataform">
		<div class="c-section c-form">
<?php

		$styles = array();
		$d = dir(PUN_ROOT.'style');
		while (($entry = $d->read()) !== false)
		{
			if ($entry != '.' && $entry != '..' && is_dir(PUN_ROOT.'style/'.$entry) && file_exists(PUN_ROOT.'style/'.$entry.'/'.$entry.'.css'))
				$styles[] = $entry;
		}
		$d->close();

?>
			<form method="post" accept-charset="utf-8" action="<?php echo pun_link($pun_url['profile_display'], $id) ?>">
			<div class="panel">
<?php if ($pun_user['is_admmod']): ?>				<input type="hidden" name="csrf_token" value="<?php echo $pun_user['csrf_token'] ?>" />
<?php endif; ?>				<div class="form-intro">
					<p><?php if (count($styles) > 1) echo $lang_profile['Display intro 1'].' ' ?><?php echo $lang_profile['Display intro 2'] ?></p>
				</div>
				<input type="hidden" name="form_sent" value="1" />
<?php

		// Only display the style selection box if there's more than one style available
		if (count($styles) == 1)
			echo "\t\t\t\t".'<input type="hidden" name="form[style]" value="'.$styles[0].'" />'."\n";
		else if (count($styles) > 1)
		{
			natcasesort($styles);

?>
				<fieldset class="textset">
					<legend><span><?php echo $lang_profile['Display legend'] ?></span></legend>
					<p class="field">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo $lang_profile['Styles'] ?></label><br />
						<span class="input"><select id="fld<?php echo $fld_count ?>" name="form[style]">
<?php

			while (list(, $temp) = @each($styles))
			{
				if ($user['style'] == $temp)
					echo "\t\t\t\t\t\t\t".'<option value="'.$temp.'" selected="selected">'.str_replace('_', ' ', $temp).'</option>'."\n";
				else
					echo "\t\t\t\t\t\t\t".'<option value="'.$temp.'">'.str_replace('_', ' ', $temp).'</option>'."\n";
			}

?>
						</select></span>
					</p>
				</fieldset>
<?php

		}

?>
				<fieldset class="radioset">
					<legend><span><?php echo $lang_profile['Post display legend'] ?></span></legend>
					<p class="field">
						<span class="input"><input type="checkbox" id="fld<?php echo ++$fld_count ?>" name="form[show_smilies]" value="1"<?php if ($user['show_smilies'] == '1') echo ' checked="checked"' ?> /> <label for="fld<?php echo $fld_count ?>"><?php echo $lang_profile['Show smilies'] ?></label></span><br />
<?php if ($pun_config['o_signatures'] == '1'): ?>						<span class="input"><input type="checkbox" id="fld<?php echo ++$fld_count ?>" name="form[show_sig]" value="1"<?php if ($user['show_sig'] == '1') echo ' checked="checked"' ?> /> <label for="fld<?php echo $fld_count ?>"><?php echo $lang_profile['Show sigs'] ?></label></span><br />
<?php endif; if ($pun_config['o_avatars'] == '1'): ?>						<span class="input"><input type="checkbox" id="fld<?php echo ++$fld_count ?>" name="form[show_avatars]" value="1"<?php if ($user['show_avatars'] == '1') echo ' checked="checked"' ?> /> <label for="fld<?php echo $fld_count ?>"><?php echo $lang_profile['Show avatars'] ?></label></span><br />
<?php endif; ?>						<span class="input"><input type="checkbox" id="fld<?php echo ++$fld_count ?>" name="form[show_img]" value="1"<?php if ($user['show_img'] == '1') echo ' checked="checked"' ?> /> <label for="fld<?php echo $fld_count ?>"><?php echo $lang_profile['Show images'] ?></label></span><br />
						<span class="input"><input type="checkbox" id="fld<?php echo ++$fld_count ?>" name="form[show_img_sig]" value="1"<?php if ($user['show_img_sig'] == '1') echo ' checked="checked"' ?> /> <label for="fld<?php echo $fld_count ?>"><?php echo $lang_profile['Show images sigs'] ?></label></span><br />
					</p>
				</fieldset>
				<fieldset class="textset">
					<legend><span><?php echo $lang_profile['Pagination options'] ?></span></legend>
					<p class="field">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo $lang_profile['Topics per page'] ?></label><br />
						<span class="input"><input type="text" id="fld<?php echo $fld_count ?>" name="form[disp_topics]" value="<?php echo $user['disp_topics'] ?>" size="6" maxlength="3" /> <em><?php echo $lang_profile['Leave blank'] ?></em></span>
					</p>
					<p class="field">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo $lang_profile['Posts per page'] ?></label><br />
						<span class="input"><input type="text" id="fld<?php echo $fld_count ?>" name="form[disp_posts]" value="<?php echo $user['disp_posts'] ?>" size="6" maxlength="3" /> <em><?php echo $lang_profile['Leave blank'] ?></em></span>
					</p>
				</fieldset>
				<p class="formsubmit"><input type="submit" class="button" name="update" value="<?php echo $lang_common['Submit'] ?>" />  <?php echo $lang_profile['Instructions'] ?></p>
			</div>
			</form>
		</div>
	</div>

</div>
<?php

	}
	else if ($section == 'signature')
	{
		if ($user['signature'] != '')
			$signature_field = "\t\t\t\t\t".'<div class="post-sig">'."\n\t\t\t\t\t\t".'<div class="sig-content">'.$parsed_signature.'</div>'."\n\t\t\t\t\t".'</div>'."\n";
		else
			$signature_field = "\t\t\t\t\t".'<p>'.$lang_profile['No sig'].'</p>'."\n";

		define('PUN_PAGE', 'profile-signature');
		require PUN_ROOT.'header.php';

		$fld_count = 0;

?>
<div id="pun-main1" class="a-section a-main">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

<?php generate_profile_menu(); ?>

	<div id="editprofile" class="b-postform">
		<div class="c-section c-form">
			<div class="panel">
				<div class="form-intro">
					<p><?php echo $lang_profile['Signature info'] ?></p>
				</div>
<?php echo $signature_field ?>
			</div>
			<form method="post" accept-charset="utf-8" action="<?php echo pun_link($pun_url['profile_signature'], $id) ?>">
			<div class="panel">
<?php if ($pun_user['is_admmod']): ?>				<input type="hidden" name="csrf_token" value="<?php echo $pun_user['csrf_token'] ?>" />
<?php endif; ?>				<input type="hidden" name="form_sent" value="1" />
<?php

$post_help = array();

if ($pun_config['p_message_bbcode'] == '1') $post_help[] = '<li><a href="'.pun_link($pun_url['help'], 'bbcode').'" onclick="window.open(this.href); return false;" title="'.$lang_common['New window warn'].'">'.$lang_common['BBCode help'].'</a></li>';
if ($pun_config['p_message_img_tag'] == '1') $post_help[] = '<li><a href="'.pun_link($pun_url['help'], 'img').'" onclick="window.open(this.href); return false;" title="'.$lang_common['New window warn'].'">'.$lang_common['img tag help'].'</a></li>';
if ($pun_config['o_smilies'] == '1') $post_help[] = '<li><a href="'.pun_link($pun_url['help'], 'smilies').'" onclick="window.open(this.href); return false;" title="'.$lang_common['New window warn'].'">'.$lang_common['Smilies help'].'</a></li>';

if (!empty($post_help))
{

?>
				<div class="form-intro">
					<ul class="optionlist">
						<?php echo implode("\n\t\t\t\t\t\t", $post_help)."\n" ?>
					</ul>
				</div>
<?php

}

?>
				<div class="textset">
					<p class="areafield">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo $lang_profile['Compose signature'].' - '.$lang_profile['Sig max length'] ?>: <?php echo $pun_config['p_sig_length'] ?> / <?php echo $lang_profile['Sig max lines'] ?>: <?php echo $pun_config['p_sig_lines'] ?></label><br />
						<span class="input"><textarea id="fld<?php echo $fld_count ?>" name="signature" rows="4" cols="65"><?php echo htmlspecialchars($user['signature']) ?></textarea></span>
					</p>
				</div>
				<p class="formsubmit"><input type="submit" class="button" name="update" value="<?php echo $lang_common['Submit'] ?>" /> <?php echo $lang_profile['Instructions'] ?></p>
			</div>
			</form>
		</div>
	</div>

</div>
<?php

	}
	else if ($section == 'avatar' && $pun_config['o_avatars'] == '1')
	{
		if ($img_size = @getimagesize($pun_config['o_avatars_dir'].'/'.$id.'.gif'))
			$avatar_format = 'gif';
		else if ($img_size = @getimagesize($pun_config['o_avatars_dir'].'/'.$id.'.jpg'))
			$avatar_format = 'jpg';
		else if ($img_size = @getimagesize($pun_config['o_avatars_dir'].'/'.$id.'.png'))
			$avatar_format = 'png';
		else
			$avatar_format = '';

		define('PUN_PAGE', 'profile-avatar');
		require PUN_ROOT.'header.php';

		$fld_count = 0;

?>
<div id="pun-main1" class="a-section a-main">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

<?php generate_profile_menu(); ?>

	<div id="editprofile" class="b-section b-dataform">
		<div class="c-section c-form">
			<form method="post" accept-charset="utf-8" action="<?php echo pun_link($pun_url['profile_avatar'], $id) ?>" enctype="multipart/form-data">
			<div class="panel">
<?php if ($pun_user['is_admmod']): ?>				<input type="hidden" name="csrf_token" value="<?php echo $pun_user['csrf_token'] ?>" />
<?php endif; ?>				<input type="hidden" name="form_sent" value="1" />
				<div class="form-intro">
					<p><?php printf($lang_profile['Avatar intro 1'], $pun_config['o_avatars_width'], $pun_config['o_avatars_height'], $pun_config['o_avatars_size'], ceil($pun_config['o_avatars_size'] / 1024)) ?><?php echo ($avatar_format != '') ? ' '.$lang_profile['Avatar intro 3'] : ' '.$lang_profile['Avatar intro 2'] ?></p>
				</div>
				<p id="req-msg" class="req-warn"><?php printf($lang_common['Required warn'], '<em class="req-text">'.$lang_common['Required mark'].'<span> '.$lang_common['Required'].'</span></em>') ?></p>
				<fieldset class="textset">
					<legend><span><?php echo $lang_profile['Avatar legend'] ?></span></legend>
					<input type="hidden" name="MAX_FILE_SIZE" value="<?php echo $pun_config['o_avatars_size'] ?>" />
<?php if ($avatar_format != ''): ?>					<p class="field"><strong class="alabel"><?php echo $lang_profile['Current avatar'] ?></strong> <span class="input"><a href="<?php echo pun_link($pun_url['delete_avatar'], $id) ?>"><?php echo $lang_profile['Delete avatar'] ?></a><img class="avatardemo" src="<?php echo $base_url.'/'.$pun_config['o_avatars_dir'].'/'.$id.'.'.$avatar_format ?>" <?php echo $img_size[3] ?> alt="<?php echo $lang_profile['Avatar'] ?>" /></span></p>
<?php endif; ?>					<p class="field required">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo $lang_profile['Upload avatar file'] ?>	<em class="req-text"><?php echo $lang_common['Required mark'].' <span>'.$lang_common['Required'].'</span>' ?></em></label><br />
						<span class="input"><input id="fld<?php echo $fld_count ?>" name="req_file" type="file" size="40" /></span>
					</p>
				</fieldset>
				<p class="formsubmit"><input type="submit" class="button" name="update" value="<?php echo $lang_common['Submit'] ?>" />  <?php echo $lang_profile['Instructions'] ?></p>
			</div>
			</form>
		</div>
	</div>

</div>
<?php

	}
	else if ($section == 'admin')
	{
		if ($pun_user['g_id'] != PUN_ADMIN && ($pun_user['g_moderator'] != '1' || $pun_config['p_mod_ban_users'] == '0'))
			message($lang_common['Bad request']);

		define('PUN_PAGE', 'profile-admin');
		require PUN_ROOT.'header.php';

		$fld_count = 0;

?>
<div id="pun-main1" class="a-section a-main">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

<?php generate_profile_menu(); ?>

	<div id="editprofile" class="b-section b-dataform">
		<div class="c-section c-form">
			<form method="post" accept-charset="utf-8" action="<?php echo pun_link($pun_url['profile_admin'], $id) ?>">
			<div class="panel">
<?php if ($pun_user['is_admmod']): ?>				<input type="hidden" name="csrf_token" value="<?php echo $pun_user['csrf_token'] ?>" />
<?php endif; ?>				<input type="hidden" name="form_sent" value="1" />
				<div class="form-intro">
					<h2><span><?php echo $lang_profile['User management legend'] ?></span></h2>
				</div>
				<fieldset class="textset">
					<legend><span><?php echo $lang_profile['User management legend'] ?></span></legend>

<?php

		if ($pun_user['g_moderator'] == '1')
		{

?>
					<p class="field">
						<strong class="alabel"><input type="submit" class="button" name="ban" value="<?php echo $lang_profile['Ban user'] ?>" /></strong><br />
						<span class="input"><?php echo $lang_profile['Ban user info'] ?></span>
					</p>
				</fieldset>
			</div>
<?php

		}
		else
		{
			if ($pun_user['id'] != $id)
			{

?>
					<p class="field">
						<label for="fld<?php echo ++$fld_count ?>"><?php echo $lang_profile['User group'] ?></label><br />
						<span class="input"><select id="fld<?php echo $fld_count ?>" name="group_id">
<?php

				$result = $db->query('SELECT g_id, g_title FROM '.$db->prefix.'groups WHERE g_id!='.PUN_GUEST.' ORDER BY g_title') or error('Unable to fetch user group list', __FILE__, __LINE__, $db->error());

				while ($cur_group = $db->fetch_assoc($result))
				{
					if ($cur_group['g_id'] == $user['g_id'] || ($cur_group['g_id'] == $pun_config['o_default_user_group'] && $user['g_id'] == ''))
						echo "\t\t\t\t\t\t\t".'<option value="'.$cur_group['g_id'].'" selected="selected">'.htmlspecialchars($cur_group['g_title']).'</option>'."\n";
					else
						echo "\t\t\t\t\t\t\t".'<option value="'.$cur_group['g_id'].'">'.htmlspecialchars($cur_group['g_title']).'</option>'."\n";
				}

?>
						</select> <input type="submit" class="button" name="update_group_membership" value="<?php echo $lang_profile['Save'] ?>" /></span>
					</p>

<?php

			}

?>
					<p class="field">
						<strong class="alabel"><?php echo $lang_profile['Ban user'] ?></strong><br />
						<span class="input"><input type="submit" class="button" name="ban" value="<?php echo $lang_profile['Ban user'] ?>" /></span>
					</p>
					<p class="field">
						<strong class="alabel"><?php echo $lang_profile['Delete user'] ?></strong><br />
						<span class="input"><input type="submit" class="button" name="delete_user" value="<?php echo $lang_profile['Delete user'] ?>" /></span>
					</p>
				</fieldset>
			</div>
<?php

			if ($user['g_id'] == PUN_ADMIN || $user['g_moderator'] == '1')
			{

?>
			<div class="panel">
				<div class="form-intro">
					<h2><span><?php echo $lang_profile['Set mods legend'] ?></span></h2>
					<p><?php echo $lang_profile['Moderator in info'] ?></p>
				</div>
<?php

				$result = $db->query('SELECT c.id AS cid, c.cat_name, f.id AS fid, f.forum_name, f.moderators FROM '.$db->prefix.'categories AS c INNER JOIN '.$db->prefix.'forums AS f ON c.id=f.cat_id WHERE f.redirect_url IS NULL ORDER BY c.disp_position, c.id, f.disp_position') or error('Unable to fetch category/forum list', __FILE__, __LINE__, $db->error());

				$cur_category = 0;
				while ($cur_forum = $db->fetch_assoc($result))
				{
					if ($cur_forum['cid'] != $cur_category)	// A new category since last iteration?
					{
						if ($cur_category)
							echo "\t\t\t\t\t\t".'</p>'."\n\t\t\t\t\t".'</fieldset>'."\n\t\t\t\t".'</div>'."\n";

						echo "\t\t\t\t".'<div class="textset">'."\n\t\t\t\t\t".'<h3 class="field"><span class="alabel">'.$lang_profile['Category'].'<span>: </span></span> <span class="input">'.$cur_forum['cat_name'].'</span></h3>'."\n\t\t\t\t\t".'<fieldset class="checkset">'."\n\t\t\t\t\t\t".'<legend><span><span class="acchide">'.$lang_profile['Category'].': '.$cur_forum['cat_name'].' - </span>'.$lang_profile['Mod set legend'].'</span></legend>'."\n\t\t\t\t\t\t".'<p class="field">'."\n";
						$cur_category = $cur_forum['cid'];
					}

					$moderators = ($cur_forum['moderators'] != '') ? unserialize($cur_forum['moderators']) : array();

					echo "\t\t\t\t\t\t\t".'<span class="input"><input type="checkbox" id="fld'.(++$fld_count).'" name="moderator_in['.$cur_forum['fid'].']" value="1"'.((in_array($id, $moderators)) ? ' checked="checked"' : '').' /> <label for="fld'.$fld_count.'">'.htmlspecialchars($cur_forum['forum_name']).'</label></span><br />'."\n";
				}

?>
						</p>
					</fieldset>
				</div>
				<p class="formsubmit"><input type="submit" class="button" name="update_forums" value="<?php echo $lang_profile['Update forums'] ?>" /> <?php echo $lang_profile['Instructions'] ?></p>
			</div>
<?php

			}
		}

?>
			</form>
		</div>
	</div>

</div>
<?php

	}
	else
		message($lang_common['Bad request']);

	require PUN_ROOT.'footer.php';
}
